SystemOrganization addCategory: #'OrbeonBPMRuntime_Tests'!

TestCase subclass: #BpmCodeAnalyzerTest
	instanceVariableNames: 'analyzer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

BpmCodeAnalyzerTest subclass: #BpmGatewayConditionCodeAnalyzerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 11/13/2016 12:27'!
setUp

	analyzer := BpmProcessConditionCodeAnalyzer new.! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:07'!
tearDown

	analyzer := nil! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testClassMessageAndForbiddenMesage

	analyzer blockCode: '[:proc | MyClass resetAll. proc class removeAll]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 2).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testDateInstanceMessage

	analyzer blockCode: '[:proc | proc taskFiveDate < Date today]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 0).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testMoreThanOneArgument

	analyzer blockCode: '[:form :proc | ]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 1).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testNameMessage

	analyzer blockCode: '[:proc | proc name isEmpty]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 1).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testOk

	analyzer blockCode: '[:proc | proc taskFiveDate < (Date fromString: ''12/12/2015'') 
and: [proc taskSixTime < (Time fromString: ''14:00'')]]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 0).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testRegularPerform

	analyzer blockCode: '[:proc | (proc perform: ''amount-2'') = 10]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 0).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testSuspiciousPerform

	analyzer blockCode: '[:proc | (proc perform: ''selectAmount:'' with: 20) = 10]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 1).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testTimeInstanceMessage

	analyzer blockCode: '[:proc | proc taskFiveDate < Time now]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 0).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testTimeStampInstanceMessage

	analyzer blockCode: '[:proc | proc taskFiveDate < TimeStamp now]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 0).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 08/02/2016 14:33'!
testValidBpmProcessMessageMessage

	analyzer blockCode: '[:proc | proc creator notEmpty]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 1).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testValidMessageToArgument

	analyzer blockCode: '[:proc | proc currentActivities removeAll]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 1).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testValidSmalltalkMessage

	analyzer blockCode: '[:proc | (proc getValueOf: ''name'') isEmpty]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 0).! !

!BpmGatewayConditionCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:06'!
testZeroArgument

	analyzer blockCode: '[ ]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 1).! !

BpmCodeAnalyzerTest subclass: #BpmTaskScriptCodeAnalyzerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!BpmTaskScriptCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:07'!
setUp

	analyzer := BpmTaskScriptCodeAnalyzer new.! !

!BpmTaskScriptCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:07'!
tearDown

	analyzer := nil! !

!BpmTaskScriptCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:12'!
testNoBlockRule

	analyzer blockCode: 'System destroy'; analyze.
	self assert: (analyzer codeWarnings size = 1).! !

!BpmTaskScriptCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:12'!
testNoTwoArgumentRule

	analyzer blockCode: '[:form | ]'; analyze.
	self assert: (analyzer codeWarnings size = 1).
	analyzer initialize.

	analyzer blockCode: '[]'; analyze.
	self assert: (analyzer codeWarnings size = 1).
	analyzer initialize.

	analyzer blockCode: '[:a :b :c | ]'; analyze.
	self assert: (analyzer codeWarnings size = 1).! !

!BpmTaskScriptCodeAnalyzerTest methodsFor: 'other' stamp: 'BrunoBB 06/25/2016 08:08'!
testOk

	analyzer blockCode: '[:proc :script| proc. script. ]'.

	analyzer analyze.

	self assert: (analyzer codeWarnings size = 0).! !

TestCase subclass: #BpmObjectSanityCheckTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!BpmObjectSanityCheckTest methodsFor: 'other' stamp: 'brunobb 01/25/2018 12:49'!
defaultTimerEventMonitor
	"The receiver answer the instance that monitor timer events"

	^BpmTimerEventMonitor default! !

!BpmObjectSanityCheckTest methodsFor: 'test' stamp: 'brunobb 01/25/2018 11:28'!
testAbortedProcessInNormalCollection
	"Aborted process must not be in <aBpmProcessDefinition> <processInstances> instance variable"

	BpmProcessDefinition getAllProcessDefinition do: [:eachProcDef | 
		self assert: (eachProcDef processInstances allSatisfy: [:eachProcInst | eachProcInst isAborted not])
	].! !

!BpmObjectSanityCheckTest methodsFor: 'test' stamp: 'brunobb 01/25/2018 09:21'!
testApplicationsIdentity
	"Check identity between <AbstractApplication> in the cache and the <AbstractApplication> of each <BpmProcessDefinition>"
	| applications |

	applications := AbstractApplication cache asArray.

	BpmProcessDefinition getAllProcessDefinition do: [:eachProcDef | 
		self assert: (applications anySatisfy: [:eachApp | eachApp == eachProcDef application]).
	]! !

!BpmObjectSanityCheckTest methodsFor: 'test' stamp: 'brunobb 01/25/2018 09:31'!
testFormFieldValueAssignments
	"<fieldRcCollection> - collection of the <BpmProcessDefinition>"

	BpmProcessDefinition getAllProcessDefinition do: [:eachProcDef | 
		eachProcDef formFieldInstances do: [:formDictionary | 
			formDictionary do: [:fieldRcCollection | 
				fieldRcCollection do: [:appFieldValue |  | formInstance assignment process valueHolder |
					formInstance := appFieldValue parentObject.
					assignment := formInstance assignment.
					process := assignment process.
					valueHolder := formInstance holderValueAt: appFieldValue name.

					"check identity of <BpmProcessDefinition> in cache with <BpmProcessDefinition> of each <AppFieldValue> via parentObject.assignment.process.definition"
					self assert: (process definition == eachProcDef).
					"check identity of each <AppFieldValue> contained in each <BpmProcessInstance> with <AppFieldValue> in general collection of <BpmProcessDefinition>"
					self assert: (valueHolder currentValues identityIncludes: appFieldValue).
					self assert: (valueHolder currentValues anySatisfy: [:each | each == appFieldValue]).
				]. 
			].
		]. 
	].! !

!BpmObjectSanityCheckTest methodsFor: 'test' stamp: 'brunobb 01/25/2018 11:29'!
testMatrixAssignmentAndTaskIdentity
	"Check process tasks with assignments in the current and finished matrix"

	BpmProcessDefinition getAllProcessDefinition do: [:eachProcDef | 
		(eachProcDef processInstances reject: [:each | each isAborted])  do: [:procInstance | | currentMatrix finishedMatrix currentAssignments finishedAssignments executedActivities |
			currentMatrix := procInstance getProcessMatrix.
			finishedMatrix := procInstance getFinishedProcessMatrix.

			currentAssignments := currentMatrix getAllAssignments.
			finishedAssignments := finishedMatrix getAllAssignments.

			procInstance currentActivities do: [:eachTask | "the task must be on the running matrix or must be taken by a user"
				self assert: ((currentAssignments anySatisfy: [:eachAssign | eachAssign task == eachTask]) or:[(BpmUser getUserOrNilWorkingOn: eachTask) notNil])].

			executedActivities := procInstance isAnonymousStartEnabled ifTrue: [procInstance executedActivities allButFirst] ifFalse: [procInstance executedActivities].
			"if the process <isAnonymousStartEnabled> --> the first task has NO assignment because is sent by an outsider"
			executedActivities do: [:eachTask | self assert: (finishedAssignments anySatisfy: [:eachAssign | eachAssign task == eachTask]) ].

		].
	].! !

!BpmObjectSanityCheckTest methodsFor: 'test' stamp: 'brunobb 01/25/2018 12:20'!
testMatrixFinishedAssignmentAndUserIdentity
	"Check sanity of Finished Assignments in the Matrix and in BpmUser inbox"

	BpmProcessDefinition getAllProcessDefinition do: [:eachProcDef | 
		(eachProcDef processInstances reject: [:each | each isAborted])  do: [:procInstance | | finishedMatrix finishedAssignments |
			finishedMatrix := procInstance getFinishedProcessMatrix.
			finishedAssignments := finishedMatrix getAllAssignments.

			self assert: (finishedAssignments allSatisfy: [:eachAssing | (BpmUser getUserOrNilFinishedTask: eachAssing task) notNil]). 

		].
	].! !

!BpmObjectSanityCheckTest methodsFor: 'test' stamp: 'brunobb 01/25/2018 12:48'!
testTimerEventsAndRunningProcess
	"Check if the event is in Event Monitor --> the process must be running (not finalized)"

	self defaultTimerEventMonitor monitoredEvents do: [:eventInstance | 
		self deny: eventInstance process hasFinalized]! !

TestCase subclass: #BpmProcessExecutionTest
	instanceVariableNames: 'procInstance procDefinition users roles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

BpmProcessExecutionTest subclass: #AllGatewaysProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!AllGatewaysProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:12'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForAllGatewaysProcess.

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'all gateways' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	^processGenerator getProcessDefinitionNamed: 'all gateways' ifNone: [self assert: false].! !

!AllGatewaysProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/14/2016 11:47'!
formInstance_task1

	^self createFormInstance: #form_task1 definitionNamed: 'task-1' app: 'ue' definitionMethod: #formDefinition_task1! !

!AllGatewaysProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/14/2016 11:47'!
formInstance_task2

	^self createFormInstance: #form_task2 definitionNamed: 'task-2' app: 'ue' definitionMethod: #formDefinition_task2! !

!AllGatewaysProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/14/2016 11:48'!
formInstance_task2_1

	^self createFormInstance: #form_task2_1 definitionNamed: 'task-2' app: 'ue' definitionMethod: #formDefinition_task2! !

!AllGatewaysProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/14/2016 11:48'!
formInstance_task3

	^self createFormInstance: #form_task3 definitionNamed: 'task-3' app: 'ue' definitionMethod: #formDefinition_task3! !

!AllGatewaysProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/14/2016 11:48'!
formInstance_task3_1

	^self createFormInstance: #form_task3_1 definitionNamed: 'task-3' app: 'ue' definitionMethod: #formDefinition_task3! !

!AllGatewaysProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/14/2016 11:48'!
formInstance_task4

	^self createFormInstance: #form_task4 definitionNamed: 'task-4' app: 'ue' definitionMethod: #formDefinition_task4! !

!AllGatewaysProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/14/2016 11:48'!
formInstance_task5

	^self createFormInstance: #form_task5 definitionNamed: 'task-5' app: 'ue' definitionMethod: #formDefinition_task5! !

!AllGatewaysProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/14/2016 11:48'!
formInstance_task5_1

	^self createFormInstance: #form_task5_1 definitionNamed: 'task-5' app: 'ue' definitionMethod: #formDefinition_task5! !

!AllGatewaysProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/14/2016 11:48'!
formInstance_task6

	^self createFormInstance: #form_task6 definitionNamed: 'task-6' app: 'ue' definitionMethod: #formDefinition_task6! !

!AllGatewaysProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/14/2016 11:49'!
formInstance_task6_1

	^self createFormInstance: #form_task6_1 definitionNamed: 'task-6' app: 'ue' definitionMethod: #formDefinition_task6! !

!AllGatewaysProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/14/2016 11:49'!
formInstance_task7

	^self createFormInstance: #form_task7 definitionNamed: 'task-7' app: 'ue' definitionMethod: #formDefinition_task7! !

!AllGatewaysProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 09/16/2016 09:10'!
setUp

	super setUp.

	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'all gateways' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'alberto' put: (BpmUser getExistingOrNewUserNamed: 'alberto').

	(BpmFrontOfficeRole getRoleNamed: 'manager' in: 'ue') grantUser: (users at: 'alberto').! !

!AllGatewaysProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/24/2016 12:22'!
testExecuteProcess_task4_to_end
	| currentTask currentTask2 gateway endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start all').
	"Step 1 - Form [task-1]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task1.
	self assert: (currentTask getDefinitionName = 'task-1').
	"Step 2 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'split 2 and 3').
	"Step 3 - Form [task-2] and [task-3]"
	currentTask :=  procInstance currentActivities first.
	currentTask2 :=  procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task2_1.
	self assert: (currentTask getDefinitionName = 'task-2').
	self processTask: currentTask2 withUserNamed: 'alberto' withForm: self formInstance_task3_1.
	self assert: (currentTask2 getDefinitionName = 'task-3').
	"Step 4 - TWO Gateway Evaluations"
	gateway := procInstance executedGateways asOrderedCollection second.
	self assert: (gateway getDefinitionName = 'merge 2 and 3').
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'task 4 or 5').
	"Step 5 - Form [task-5]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task4.
	self assert: (currentTask getDefinitionName = 'task-4').
	"Step 6 - Form [task-6]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task6.
	self assert: (currentTask getDefinitionName = 'task-6').
	"Step 7 - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'end all') and: [endArtifact isEndEvent]).! !

!AllGatewaysProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/24/2016 12:06'!
testExecuteProcess_task4_to_task7
	| currentTask currentTask2 gateway endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start all').
	"Step 1 - Form [task-1]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task1.
	self assert: (currentTask getDefinitionName = 'task-1').
	"Step 2 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'split 2 and 3').
	"Step 3 - Form [task-2] and [task-3]"
	currentTask :=  procInstance currentActivities first.
	currentTask2 :=  procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task2_1.
	self assert: (currentTask getDefinitionName = 'task-2').
	self processTask: currentTask2 withUserNamed: 'alberto' withForm: self formInstance_task3_1.
	self assert: (currentTask2 getDefinitionName = 'task-3').
	"Step 4 - TWO Gateway Evaluations"
	gateway := procInstance executedGateways asOrderedCollection second.
	self assert: (gateway getDefinitionName = 'merge 2 and 3').
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'task 4 or 5').
	"Step 5 - Form [task-5]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task4.
	self assert: (currentTask getDefinitionName = 'task-4').
	"Step 6 - Form [task-6]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task6_1.
	self assert: (currentTask getDefinitionName = 'task-6').
	"Step 7 - Form [task-7]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task7.
	self assert: (currentTask getDefinitionName = 'task-7').
	"Step 8 - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'end all') and: [endArtifact isEndEvent]).! !

!AllGatewaysProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/24/2016 12:25'!
testExecuteProcess_task5_task7_to_end
	| currentTask currentTask2 gateway endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start all').
	"Step 1 - Form [task-1]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task1.
	self assert: (currentTask getDefinitionName = 'task-1').
	"Step 2 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'split 2 and 3').
	"Step 3 - Form [task-2] and [task-3]"
	currentTask :=  procInstance currentActivities first.
	currentTask2 :=  procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task2.
	self assert: (currentTask getDefinitionName = 'task-2').
	self processTask: currentTask2 withUserNamed: 'alberto' withForm: self formInstance_task3.
	self assert: (currentTask2 getDefinitionName = 'task-3').
	"Step 4 - TWO Gateway Evaluations"
	gateway := procInstance executedGateways asOrderedCollection second.
	self assert: (gateway getDefinitionName = 'merge 2 and 3').
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'task 4 or 5').
	"Step 5 - Form [task-5]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task5.
	self assert: (currentTask getDefinitionName = 'task-5').
	"Step 6 - Form [task-6]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task6_1.
	self assert: (currentTask getDefinitionName = 'task-6').
	"Step 7 - Form [task-7]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task7.
	self assert: (currentTask getDefinitionName = 'task-7').
	"Step 8 - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'end all') and: [endArtifact isEndEvent]).! !

!AllGatewaysProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/24/2016 12:23'!
testExecuteProcess_task5_to_end
	| currentTask currentTask2 gateway endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start all').
	"Step 1 - Form [task-1]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task1.
	self assert: (currentTask getDefinitionName = 'task-1').
	"Step 2 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'split 2 and 3').
	"Step 3 - Form [task-2] and [task-3]"
	currentTask :=  procInstance currentActivities first.
	currentTask2 :=  procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task2.
	self assert: (currentTask getDefinitionName = 'task-2').
	self processTask: currentTask2 withUserNamed: 'alberto' withForm: self formInstance_task3.
	self assert: (currentTask2 getDefinitionName = 'task-3').
	"Step 4 - TWO Gateway Evaluations"
	gateway := procInstance executedGateways asOrderedCollection second.
	self assert: (gateway getDefinitionName = 'merge 2 and 3').
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'task 4 or 5').
	"Step 5 - Form [task-5]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task5.
	self assert: (currentTask getDefinitionName = 'task-5').
	"Step 6 - Form [task-6]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_task6.
	self assert: (currentTask getDefinitionName = 'task-6').
	"Step 7 - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'end all') and: [endArtifact isEndEvent]).! !

!AllGatewaysProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/19/2016 16:13'!
testFieldsInGatewayConditions

	self assert: (procDefinition hasGatewayConditionIncludingFieldNamed: 'taskTwoOption').

	self assert: (procDefinition hasGatewayConditionIncludingFieldNamed: 'taskThreeOption').

	self assert: (procDefinition hasGatewayConditionIncludingFieldNamed: 'taskFiveDate').

	self assert: (procDefinition hasGatewayConditionIncludingFieldNamed: 'taskSixTime').

	self deny: (procDefinition hasGatewayConditionIncludingFieldNamed: 'name').

	self deny: (procDefinition hasGatewayConditionIncludingFieldNamed: 'surname').! !

BpmProcessExecutionTest subclass: #AllTypeConditionsProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!AllTypeConditionsProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:12'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForAllConditionsType.

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'all-type-conditions' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	^processGenerator getProcessDefinitionNamed: 'all-type-conditions' ifNone: [self assert: false].! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'form instance' stamp: 'BrunoBB 07/15/2016 05:31'!
formInstance_amount_exit

	^self createFormInstance: #form_amount_exit definitionNamed: 'all-field-types' app: 'ue' definitionMethod: #formDefinition_all_types! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'form instance' stamp: 'BrunoBB 07/15/2016 05:31'!
formInstance_boolean_exit

	^self createFormInstance: #form_boolean_exit definitionNamed: 'all-field-types' app: 'ue' definitionMethod: #formDefinition_all_types! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'form instance' stamp: 'BrunoBB 07/15/2016 05:31'!
formInstance_date_exit

	^self createFormInstance: #form_date_exit definitionNamed: 'all-field-types' app: 'ue' definitionMethod: #formDefinition_all_types! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'form instance' stamp: 'BrunoBB 07/15/2016 05:31'!
formInstance_string_exit

	^self createFormInstance: #form_string_exit definitionNamed: 'all-field-types' app: 'ue' definitionMethod: #formDefinition_all_types! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'form instance' stamp: 'BrunoBB 07/15/2016 05:31'!
formInstance_time_exit

	^self createFormInstance: #form_time_exit definitionNamed: 'all-field-types' app: 'ue' definitionMethod: #formDefinition_all_types! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'form instance' stamp: 'BrunoBB 07/15/2016 05:31'!
formInstance_timeStamp_exit

	^self createFormInstance: #form_timeStamp_exit definitionNamed: 'all-field-types' app: 'ue' definitionMethod: #formDefinition_all_types! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 09/16/2016 09:10'!
setUp

	super setUp.
	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'all-type-conditions' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'alberto' put: (BpmUser getExistingOrNewUserNamed: 'alberto').

	(BpmFrontOfficeRole getRoleNamed: 'runner' in: 'ue') grantUser: (users at: 'alberto').! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/24/2016 15:31'!
testExecuteProcess_amount_exit
	| currentTask gateway endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [task-1]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_amount_exit.
	self assert: (currentTask getDefinitionName = 'all-field-types').
	"Step 2 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'gateway split').
	"Step 3 - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'integer end') and: [endArtifact isEndEvent]).! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/24/2016 15:29'!
testExecuteProcess_boolean_exit
	| currentTask gateway endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [task-1]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_boolean_exit.
	self assert: (currentTask getDefinitionName = 'all-field-types').
	"Step 2 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'gateway split').
	"Step 3 - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'boolean end') and: [endArtifact isEndEvent]).! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 01/30/2018 13:43'!
testExecuteProcess_boolean_exit_aborted
	| currentTask assignment processId currentProcessMatrix finishedProcessMatrix |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [task-1]"
	currentTask := procInstance currentActivities last.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'runner' satisfying: {:assign | assign.processId = processId}) notEmpty.
	assignment := self takeTask: currentTask forUserNamed: 'alberto' withForm: self formInstance_boolean_exit on: procInstance. "assignment is not finished"

	self assert: (currentTask getDefinitionName = 'all-field-types').
	self assert: ((procDefinition getCollectionForFieldsNamed: 'boolean[b]' in: 'all-field-types') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'runner' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: (finishedProcessMatrix getAvailableTasksFor: 'runner' satisfying: {:assign | assign.processId = processId}) isEmpty.

	self finalizeAssignment: assignment withUserNamed: 'alberto' on: procInstance. "assignment is finished"
	self assert: (finishedProcessMatrix getAvailableTasksFor: 'runner' satisfying: {:assign | assign.processId = processId}) notEmpty.


	procInstance abortProcess: nil.
	procInstance currentState isConfirmed: true. 
	procInstance confirmAbortion.

	self assert: ((procDefinition getCollectionForFieldsNamed: 'boolean[b]' in: 'all-field-types') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'runner' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: (finishedProcessMatrix getAvailableTasksFor: 'runner' satisfying: {:assign | assign.processId = processId}) isEmpty.! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/24/2016 15:30'!
testExecuteProcess_date_exit
	| currentTask gateway endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [task-1]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_date_exit.
	self assert: (currentTask getDefinitionName = 'all-field-types').
	"Step 2 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'gateway split').
	"Step 3 - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'date end') and: [endArtifact isEndEvent]).! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/24/2016 15:30'!
testExecuteProcess_string_exit
	| currentTask gateway endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [task-1]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_string_exit.
	self assert: (currentTask getDefinitionName = 'all-field-types').
	"Step 2 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'gateway split').
	"Step 3 - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'string end') and: [endArtifact isEndEvent]).! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/24/2016 15:30'!
testExecuteProcess_time_exit
	| currentTask gateway endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [task-1]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_time_exit.
	self assert: (currentTask getDefinitionName = 'all-field-types').
	"Step 2 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'gateway split').
	"Step 3 - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'time end') and: [endArtifact isEndEvent]).! !

!AllTypeConditionsProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/24/2016 15:31'!
testExecuteProcess_timeStamp_exit
	| currentTask gateway endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [task-1]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_timeStamp_exit.
	self assert: (currentTask getDefinitionName = 'all-field-types').
	"Step 2 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'gateway split').
	"Step 3 - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'time stamp end') and: [endArtifact isEndEvent]).! !

!BpmProcessExecutionTest class methodsFor: 'other' stamp: 'brunobb 01/23/2018 11:11'!
getFinishedMatrixManagerClass

	^BpmFinishedTasksMatrix! !

!BpmProcessExecutionTest methodsFor: 'execution simulation' stamp: 'brunobb 02/01/2018 13:19'!
associate: aBpmTaskAssignment withForm: anOrbeonFormInstance on: aBpmProcessInstance
	""

	aBpmTaskAssignment task externalObject: anOrbeonFormInstance.
	anOrbeonFormInstance assignment: aBpmTaskAssignment.

	^aBpmTaskAssignment! !

!BpmProcessExecutionTest methodsFor: 'forms creation' stamp: 'BrunoBB 08/13/2016 09:53'!
createDefinition: formName with: definitionMethod in: anOrbeonApplication
	| savedDefinition |

	savedDefinition := OrbeonSavedFormDefinition app: anOrbeonApplication applicationName form: formName.
	savedDefinition id: UUID new asString;
		version: 1;
		title: formName;
		setXmlString: (OrbeonFormDefinitionTemplate perform: definitionMethod).

	anOrbeonApplication addSavedDefinition: savedDefinition.

	savedDefinition definition 
		publish; 
		processXMLDefinition.

	anOrbeonApplication addPublishedDefinition: savedDefinition definition.

	^savedDefinition definition! !

!BpmProcessExecutionTest methodsFor: 'forms creation' stamp: 'brunobb 01/04/2018 13:05'!
createFormInstance: xmlMethodName definitionNamed: definitionName app: app definitionMethod: definitionMethod
	"The receiver create anOrbeonFormInstance of form definition named <definitionName> of Orbeon Applicaiton named <app> using the method <xmlMethodName> to get the XML string of the form "

	^self createFormInstance: xmlMethodName definitionNamed: definitionName app: app definitionMethod: definitionMethod in: procInstance! !

!BpmProcessExecutionTest methodsFor: 'forms creation' stamp: 'brunobb 01/04/2018 13:04'!
createFormInstance: xmlMethodName definitionNamed: definitionName app: app definitionMethod: definitionMethod in: aBpmProcessInstance
	"The receiver create anOrbeonFormInstance of form definition named <definitionName> of Orbeon Applicaiton named <app> using the method <xmlMethodName> to get the XML string of the form "
	| application definition formInstance |

	application := self getApplicationManagerClass getAnyApplicationNamed: app.
	definition := application definitionNamed: definitionName ifNone: [self createDefinition: definitionName with: definitionMethod in: application].

	formInstance := 
		(OrbeonFormInstance newFor: definition withId: UUID new asString)
			definition: definition;
			xmlString: (OrbeonFormInstanceTemplate perform: xmlMethodName);
			processXML;
			yourself.

	aBpmProcessInstance definition updateFieldsOf: formInstance. "create AppFieldValue for the process definition"

	^formInstance! !

!BpmProcessExecutionTest methodsFor: 'timer' stamp: 'brunobb 11/02/2017 12:44'!
defaultTimerEventMonitor
	"The receiver answer the instance that monitor timer events"

	^BpmTimerEventMonitor default! !

!BpmProcessExecutionTest methodsFor: 'execution simulation' stamp: 'brunobb 01/30/2018 13:42'!
finalizeAssignment: aBpmTaskAssignment withUserNamed: aString on: aBpmProcessInstance
	"The receiver get the <BpmUser> named <aString> to finalize the assignment <aBpmTaskAssignment>"

	(self getUserNamed: aString) finalizeAssignment: aBpmTaskAssignment.

	"the assignment has been finished (by the role or by all performers) --> this must be in the finished matrix"
	(aBpmTaskAssignment isFinishedByPerformers)
	ifTrue: [(self getFinishedAssignmentFor: aBpmTaskAssignment task on: aBpmProcessInstance ifNone: [nil]) ifNil: [self assert: false]]! !

!BpmProcessExecutionTest methodsFor: 'execution simulation' stamp: 'brunobb 01/30/2018 13:41'!
getAssignmentAndAssociate: aBpmTaskInstance withForm: anOrbeonFormInstance on: aBpmProcessInstance
	"The receiver get the <aBpmTaskAssignment> for <aBpmTaskInstance> from the <aBpmTasksHolderMatrix> and associate the three:
	<aBpmTaskInstance> <--> <anOrbeonFormInstance>
	<aBpmTaskAssignment> <--> <anOrbeonFormInstance>"

	| assignment |

	assignment := self getAssignmentFor: aBpmTaskInstance on: aBpmProcessInstance.

	aBpmTaskInstance externalObject: anOrbeonFormInstance.
	anOrbeonFormInstance assignment: assignment.

	^assignment! !

!BpmProcessExecutionTest methodsFor: 'execution simulation' stamp: 'BrunoBB 03/29/2016 14:31'!
getAssignmentFor: aBpmTaskInstance on: aBpmProcessInstance
	"The receiver get the assignment for <aBpmTaskInstance> in the process <aBpmProcessInstance>. 
	1- Get the matrix (BpmTasksHolderMatrix) based on the application that the process <aBpmProcessInstance> belong.
	2- Get the assignment for the roles of the task <aBpmTaskInstance>"

	^self getAssignmentFor: aBpmTaskInstance on: aBpmProcessInstance ifNone: [self assert: false]! !

!BpmProcessExecutionTest methodsFor: 'execution simulation' stamp: 'BrunoBB 03/29/2016 14:30'!
getAssignmentFor: aBpmTaskInstance on: aBpmProcessInstance ifNone: aBlock
	"The receiver get the assignment for <aBpmTaskInstance> in the process <aBpmProcessInstance>. 
	1- Get the matrix (BpmTasksHolderMatrix) based on the application that the process <aBpmProcessInstance> belong.
	2- Get the assignment for the roles of the task <aBpmTaskInstance>"

	^(self getProcessMatrixFor: aBpmProcessInstance) getAssignmentFor: aBpmTaskInstance ifNone: aBlock! !

!BpmProcessExecutionTest methodsFor: 'execution simulation' stamp: 'BrunoBB 03/29/2016 14:44'!
getFinishedAssignmentFor: aBpmTaskInstance on: aBpmProcessInstance
	"The receiver get the assignment for <aBpmTaskInstance> in the process <aBpmProcessInstance>. 
	1- Get the matrix (BpmTasksHolderMatrix) based on the application that the process <aBpmProcessInstance> belong.
	2- Get the assignment for the roles of the task <aBpmTaskInstance>"

	^(self getFinishedProcessMatrixFor: aBpmProcessInstance) getAssignmentFor: aBpmTaskInstance ifNone: [self assert: false]! !

!BpmProcessExecutionTest methodsFor: 'execution simulation' stamp: 'BrunoBB 03/29/2016 14:43'!
getFinishedAssignmentFor: aBpmTaskInstance on: aBpmProcessInstance ifNone: aBlock
	"The receiver get the assignment for <aBpmTaskInstance> in the process <aBpmProcessInstance>. 
	1- Get the matrix (BpmTasksHolderMatrix) based on the application that the process <aBpmProcessInstance> belong.
	2- Get the assignment for the roles of the task <aBpmTaskInstance>"

	^(self getFinishedProcessMatrixFor: aBpmProcessInstance) getAssignmentFor: aBpmTaskInstance ifNone: aBlock! !

!BpmProcessExecutionTest methodsFor: 'task matrix' stamp: 'brunobb 01/23/2018 11:11'!
getFinishedMatrixManagerClass

	^self class getFinishedMatrixManagerClass! !

!BpmProcessExecutionTest methodsFor: 'task matrix' stamp: 'BrunoBB 03/29/2016 14:41'!
getFinishedProcessMatrix

	^self getFinishedProcessMatrixFor: procInstance! !

!BpmProcessExecutionTest methodsFor: 'task matrix' stamp: 'BrunoBB 03/29/2016 14:41'!
getFinishedProcessMatrixFor: aBpmProcessInstance

	^aBpmProcessInstance getFinishedProcessMatrix! !

!BpmProcessExecutionTest methodsFor: 'task matrix' stamp: 'BrunoBB 12/07/2015 06:51'!
getProcessMatrix

	^self getProcessMatrixFor: procInstance! !

!BpmProcessExecutionTest methodsFor: 'task matrix' stamp: 'BrunoBB 12/07/2015 06:51'!
getProcessMatrixFor: aBpmProcessInstance

	^aBpmProcessInstance getProcessMatrix! !

!BpmProcessExecutionTest methodsFor: 'users' stamp: 'BrunoBB 03/27/2016 16:13'!
getUserNamed: aString

	^users at: aString ifAbsent: [self assert: false]! !

!BpmProcessExecutionTest methodsFor: 'execution simulation' stamp: 'BrunoBB 12/07/2015 06:59'!
processTask: aBpmTaskInstance withUserNamed: aString withForm: anOrbeonFormInstance
	"The receiver simulate the task processing of <aBpmTaskInstance> by user named <aString> in the process <aBpmProcessInstance>. 
	The task has the form instance <anOrbeonFormInstance>.
	1- Get the actual assignment of the task <aBpmTaskAssignment> from the tasks matrix.
	2- The user take the assignment.
	3- Associate the task and the form instance.
	4- The user finalize the assigment"

	^self processTask: aBpmTaskInstance withUserNamed: aString withForm: anOrbeonFormInstance on: procInstance! !

!BpmProcessExecutionTest methodsFor: 'execution simulation' stamp: 'brunobb 01/30/2018 13:43'!
processTask: aBpmTaskInstance withUserNamed: aString withForm: anOrbeonFormInstance on: aBpmProcessInstance
	"The receiver simulate the task processing of <aBpmTaskInstance> by user named <aString> in the process <aBpmProcessInstance>. 
	The task has the form instance <anOrbeonFormInstance>.
	1- Get the actual assignment of the task <aBpmTaskAssignment> from the tasks matrix.
	2- The user take the assignment.
	3- Associate the task and the form instance.
	4- The user finalize the assigment"
	| assignment |

	assignment := self takeTask: aBpmTaskInstance forUserNamed: aString withForm: anOrbeonFormInstance on: aBpmProcessInstance.

	(self getAssignmentFor: aBpmTaskInstance on: aBpmProcessInstance ifNone: [nil]) 
	ifNotNil: [self assert: false]. "the assignment has been already taken --> this must answer nil"

	self finalizeAssignment: assignment withUserNamed: aString on: aBpmProcessInstance! !

!BpmProcessExecutionTest methodsFor: 'Accessing' stamp: 'BrunoBB 12/07/2015 06:51'!
procInstance
	^procInstance! !

!BpmProcessExecutionTest methodsFor: 'Updating' stamp: 'BrunoBB 12/07/2015 06:51'!
procInstance: newValue
	procInstance := newValue! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 09/17/2016 07:40'!
setUp

	super setUp.

	self getOrbeonApplicationClass 
		getAnyApplicationNamed: 'ue' 
		ifNone: [(self getOrbeonApplicationClass newNamed: 'ue') addToCache].! !

!BpmProcessExecutionTest methodsFor: 'execution simulation' stamp: 'brunobb 01/30/2018 13:37'!
takeTask: aBpmTaskInstance forUserNamed: aString withForm: anOrbeonFormInstance on: aBpmProcessInstance
	"The receiver take the task <aBpmTaskInstance> for user named <aString> in the process <aBpmProcessInstance>. 
	The task has the form instance <anOrbeonFormInstance>.
	1- Get the actual assignment of the task <aBpmTaskAssignment> from the tasks matrix.
	2- The user take the assignment.
	3- Associate the task and the form instance.
	4- Answer the assignment <aBpmTaskAssignment>"
	| assignment |

	assignment := self getAssignmentAndAssociate: aBpmTaskInstance withForm: anOrbeonFormInstance on: aBpmProcessInstance.

	"if <aBpmProcessInstance> is not running the anException stop the execution.
	Before #take: the object structure has to be connected (see above method):
		aBpmTaskInstance externalObject: anOrbeonFormInstance.
		anOrbeonFormInstance assignment: assignment.
	if not --> the object structure is broken (see issue #364)"
	(self getUserNamed: aString) take: assignment. 

	^assignment! !

BpmProcessExecutionTest subclass: #DataEntryMultiRoleProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!DataEntryMultiRoleProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:13'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForDataEntryProcess.

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'multi-role' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	^processGenerator getProcessDefinitionNamed: 'multi-role' ifNone: [self assert: false].! !

!DataEntryMultiRoleProcessExecutionTest methodsFor: 'form instance' stamp: 'BrunoBB 07/15/2016 09:10'!
formInstance_data_approved

	^self createFormInstance: #form_data_approved_1 definitionNamed: 'data-approved' app: 'ue' definitionMethod: #formDefinition_data_approval! !

!DataEntryMultiRoleProcessExecutionTest methodsFor: 'form instance' stamp: 'BrunoBB 07/15/2016 09:10'!
formInstance_data_entry

	^self createFormInstance: #form_data_entry_1 definitionNamed: 'data-entry' app: 'ue' definitionMethod: #formDefinition_data_entry! !

!DataEntryMultiRoleProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 09/16/2016 09:10'!
setUp

	super setUp.
	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'multi-role' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'alberto' put: (BpmUser getExistingOrNewUserNamed: 'alberto'). "data-entry-1"
	users at: 'juan' put: (BpmUser getExistingOrNewUserNamed: 'juan'). "data-entry-2"
	users at: 'mario' put: (BpmUser getExistingOrNewUserNamed: 'mario')."data-entry-3"
	users at: 'bruno' put: (BpmUser getExistingOrNewUserNamed: 'bruno')."approver"

	(BpmFrontOfficeRole getRoleNamed: 'data-entry-1' in: 'ue') grantUser: (users at: 'alberto').
	(BpmFrontOfficeRole getRoleNamed: 'data-entry-2' in: 'ue') grantUser: (users at: 'juan').
	(BpmFrontOfficeRole getRoleNamed: 'data-entry-3' in: 'ue') grantUser: (users at: 'mario').
	(BpmFrontOfficeRole getRoleNamed: 'approver' in: 'ue') grantUser: (users at: 'bruno').

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').! !

!DataEntryMultiRoleProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/13/2016 09:31'!
testExecuteProcess_data_entry_approved
	| currentTask endArtifact |

	self assert: (procInstance startEvent getDefinitionName = 'start multi role').
	"Step 1.1 - Form [data-entry]" "Performer 1"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask finalizedPerformerCounter = 0).
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_data_entry.
	self assert: ((currentTask getCurrentRoleIfNone: [self assert: false]) name = 'data-entry-1').
	self assert: ((currentTask rolesWhoWorked last) name = 'data-entry-1').
	self assert: (currentTask getDefinitionName = 'data-entry').
	self assert: (currentTask finalizedPerformerCounter = 1).
	"Step 1.2 - Form [data-entry]" "Performer 2"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'juan' withForm: self formInstance_data_entry.
	self assert: ((currentTask getCurrentRoleIfNone: [self assert: false]) name = 'data-entry-2').
	self assert: ((currentTask rolesWhoWorked last) name = 'data-entry-2').
	self assert: (currentTask getDefinitionName = 'data-entry').
	self assert: (currentTask finalizedPerformerCounter = 2).
	"Step 1.3 - Form [data-entry]" "Performer 3"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'mario' withForm: self formInstance_data_entry.
	self assert: ((currentTask getCurrentRoleIfNone: [self assert: false]) name = 'data-entry-3').
	self assert: ((currentTask rolesWhoWorked last) name = 'data-entry-3').
	self assert: (currentTask getDefinitionName = 'data-entry').
	self assert: (currentTask finalizedPerformerCounter = 3).
	"Step 2 - Form [data-approved]" 
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'bruno' withForm: self formInstance_data_approved.
	self assert: (currentTask getDefinitionName = 'data-approved').
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'end multi role') and: [endArtifact isEndEvent]).! !

BpmProcessExecutionTest subclass: #DefaultTransitionProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!DefaultTransitionProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:13'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForDefaultTransition.

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'default-transition-process' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	^processGenerator getProcessDefinitionNamed: 'default-transition-process' ifNone: [self assert: false].! !

!DefaultTransitionProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 09/16/2016 09:11'!
setUp

	super setUp.
	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'default-transition-process' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'alberto' put: (BpmUser getExistingOrNewUserNamed: 'alberto').

	(BpmFrontOfficeRole getRoleNamed: 'administrator' in: 'ue') grantUser: (users at: 'alberto').! !

!DefaultTransitionProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 07/08/2016 12:24'!
testExecuteProcess
	| endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	"Start Step"
	self assert: (procInstance startEvent getDefinitionName = 'start').

	"End Step"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
	self assert: procInstance hasFinalized.

	self assert: (procInstance randomInteger = 10). "<randomInteger> is a variable is a Script"
	self assert: (procInstance age = 40).
	procInstance executedScripts do: [:each | 
		self assert: (#('script_1' 'script_2' 'script_4' 'script_5') includes: each getDefinitionName)].

	self assert: (procInstance executedScripts size = 4).! !

BpmProcessExecutionTest subclass: #EmbeddedSubProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!EmbeddedSubProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:13'!
createProcessDefinition
	| generator reader |

	reader:= XPDLProcessDefinitionTemplate xpdlReaderForReusableEmbeddedProcess.

	generator := BpmProcessGenerator on: reader xpdlPackages.

	generator 
		mapProcess: 'ReusableEmbeddedProc' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		mapProcess: 'Reusable-Script' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	^generator getProcessDefinitionNamed: 'ReusableEmbeddedProc' ifNone: []! !

!EmbeddedSubProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 09/16/2016 09:11'!
setUp

	super setUp.
	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'ReusableEmbeddedProc' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'alberto' put: (BpmUser getExistingOrNewUserNamed: 'alberto').

	(BpmFrontOfficeRole getRoleNamed: 'administrator' in: 'ue') grantUser: (users at: 'alberto').! !

!EmbeddedSubProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 06/26/2016 16:09'!
testExecuteProcess
	| script endArtifact subProcessEmb subProcessReus |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Script Execution"
	script := procInstance executedScripts last.
	self assert: (script isFinished).

	"Step 2 - After the Script the embedded subprocess is created"
		subProcessEmb := procInstance subprocesses first.
		self assert: (procInstance includesSubProcess: subProcessEmb).
		self assert:  subProcessEmb isSubProcess.
		self assert: (subProcessEmb startEvent getDefinitionName = 'start-embedded').
		self assert: (subProcessEmb hasFinalized).
		endArtifact := subProcessEmb endEvents asOrderedCollection last.
		self assert: ((endArtifact getDefinitionName = 'end-embedded') and: [endArtifact isEndEvent]).

		subProcessReus := procInstance subprocesses last.
		self assert: (procInstance includesSubProcess: subProcessReus).
		self assert:  subProcessReus isSubProcess.
		self assert: (subProcessReus startEvent getDefinitionName = 'start-resusable').
		self assert: (subProcessReus hasFinalized).
		endArtifact := subProcessReus endEvents asOrderedCollection last.
		self assert: ((endArtifact getDefinitionName = 'end-reusable') and: [endArtifact isEndEvent]).
	"Step X - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
	self assert: procInstance hasFinalized.! !

BpmProcessExecutionTest subclass: #ScriptProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!ScriptProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:13'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForScriptProcess.

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'Process with Scripts' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	^processGenerator getProcessDefinitionNamed: 'Process with Scripts' ifNone: [self assert: false].! !

!ScriptProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 09/16/2016 09:11'!
setUp

	super setUp.
	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'Process with Scripts' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'alberto' put: (BpmUser getExistingOrNewUserNamed: 'alberto').

	(BpmFrontOfficeRole getRoleNamed: 'manager' in: 'ue') grantUser: (users at: 'alberto').! !

!ScriptProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 06/24/2016 10:38'!
tearDown

	super tearDown.

"	Smalltalk removeKey: #Test_Temps ifAbsent: []."! !

!ScriptProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 06/24/2016 11:04'!
testExecuteProcess
	| script endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'alberto').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Script Execution"
	script := procInstance executedScripts last.
	self assert: (script isFinished).
	self assert: (Smalltalk includesKey: #Test_Temps).
	self assert: (procInstance getScriptVariableNamed: 'myTempVar' ifNone: [^self assert: false]) = 64.

	"Step 2 - Process End"
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
	self assert: procInstance hasFinalized.! !

BpmProcessExecutionTest subclass: #SimpleRegistrationProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!SimpleRegistrationProcessExecutionTest commentStamp: 'BrunoBB 04/19/2016 15:10' prior: 0!
This is an Anonymous Process. The process is started by an Anonymous User.!

!SimpleRegistrationProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:14'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForSimpleRegistrationProcess.

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'Simple Registration' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'st');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	"Associate the anonymous form with the ProcessDefinition"
	BpmProcessDefinition 
		registerAnonymousMappingForm: 'simple-registration' 
		in: 'st' 
		for: (BpmProcessDefinition getAllProcessesNamed: 'Simple Registration' in: 'st') last.

	^processGenerator getProcessDefinitionNamed: 'Simple Registration' ifNone: [self assert: false].! !

!SimpleRegistrationProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/15/2016 09:06'!
formInstance_registration_approval

	^self createFormInstance: #form_registration_approval_1 definitionNamed: 'registration-approval' app: 'st' definitionMethod: #formDefinition_registration_approval! !

!SimpleRegistrationProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/15/2016 09:06'!
formInstance_simple_registration

	^self createFormInstance: #form_simple_registration_1 definitionNamed: 'simple-registration' app: 'st' definitionMethod: #formDefinition_simple_registration! !

!SimpleRegistrationProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 01/31/2018 09:59'!
getAssignmentFor: aBpmTaskInstance

	^(BpmTaskAssignment newFor: procInstance task: aBpmTaskInstance in: self getFinishedMatrix)
		role: (BpmFrontOfficeRole createNewOrGetExisting: 'anonymous-user' in: 'st');
		yourself! !

!SimpleRegistrationProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 01/14/2018 09:32'!
getFinishedMatrix

	^self getFinishedMatrixManagerClass getMatrixForApplicationNamed: 'st'! !

!SimpleRegistrationProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 09/17/2016 08:04'!
setUp

	self getApplicationManagerClass 
		getAnyApplicationNamed: 'st' 
		ifNone: [(self getOrbeonApplicationClass newNamed: 'st') addToCache].

	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'Simple Registration' in: 'st'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'alberto' put: (BpmUser getExistingOrNewUserNamed: 'alberto').

	(BpmFrontOfficeRole getRoleNamed: 'approver' in: 'st') grantUser: (users at: 'alberto').

	procInstance := procDefinition createAndStartProcessInstance: nil. "this process is started by an anonymous user"! !

!SimpleRegistrationProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 03/31/2016 17:50'!
testExecuteProcess_simpleRegistration_approved
	| currentTask endArtifact formInstance |

	self assert: (procInstance startEvent getDefinitionName = 'start-registration').
	"Step 1 - Form [simple-registration]" "THIS IS AN ANONYMOUS PROCESS"
	currentTask := procInstance currentActivities last.
	formInstance := self formInstance_simple_registration.
	currentTask externalObject: formInstance.
	formInstance assignment: (self getAssignmentFor: currentTask).
	currentTask finalize.

	self assert: (currentTask getDefinitionName = 'simple-registration').
	self assert: procInstance startEventIsAnonymous.
	procInstance generateNextTransitionsFrom: currentTask.
	"Step 2 - Form [registration-approval]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_registration_approval.
	self assert: (currentTask getDefinitionName = 'registration-approval').

	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

BpmProcessExecutionTest subclass: #TaskTimerProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!TaskTimerProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:14'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForTimerTask. 

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'task_timer' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	^processGenerator getProcessDefinitionNamed: 'task_timer' ifNone: [self assert: false].! !

!TaskTimerProcessExecutionTest methodsFor: 'form instance' stamp: 'brunobb 11/02/2017 12:49'!
formInstance_set_timer_term

	^self createFormInstance: #form_set_timer_term_1 definitionNamed: 'set-timer-term' app: 'ue' definitionMethod: #formDefinition_set_timer_term! !

!TaskTimerProcessExecutionTest methodsFor: 'form instance' stamp: 'brunobb 11/02/2017 13:13'!
formInstance_set_timer_term_2

	^self createFormInstance: #form_set_timer_term_2 definitionNamed: 'set-timer-term' app: 'ue' definitionMethod: #formDefinition_set_timer_term! !

!TaskTimerProcessExecutionTest methodsFor: 'form instance' stamp: 'brunobb 11/02/2017 12:49'!
formInstance_user_form

	^self createFormInstance: #form_user_form_1 definitionNamed: 'user-form' app: 'ue' definitionMethod: #formDefinition_user_form! !

!TaskTimerProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 10/17/2017 05:27'!
setUp

	super setUp.
	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'task_timer' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'andrew vm' put: (BpmUser getExistingOrNewUserNamed: 'andrew vm').

	(BpmFrontOfficeRole createNewOrGetExisting: 'timer-role' in: 'ue') grantUser: (users at: 'andrew vm').! !

!TaskTimerProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 11/02/2017 13:50'!
testExecuteProcess_01
	| currentTask |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'andrew vm').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [set-timer-term]"

	currentTask := procInstance currentActivities last.

	self assert: (procInstance currentActivities size = 1).
	self assert: (procInstance currentActivities last attachedEvents size = 1).
	self assert: (currentTask getDefinitionName = 'set-timer-term').

	"formInstance_set_timer_term: is set with 60 seconds and this number is used by timer named Term to wait before finishing the process"

	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_set_timer_term.  "60 seconds to wait"

	self assert: ((procInstance getEventsNamed: 'term' ifNone: [self assert: false]) size = 1).
	self assert: procInstance currentActivities isEmpty.

	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: procInstance currentActivities isEmpty.
	self assert: ((procInstance getEventsNamed: 'term' ifNone: [self assert: false]) size = 1).
	self deny: procInstance hasFinalized.
	(Delay forSeconds: 30) wait.
	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: procInstance currentActivities isEmpty.
	self assert: ((procInstance getEventsNamed: 'term' ifNone: [self assert: false]) size = 1).
	self deny: procInstance hasFinalized.
	(Delay forSeconds: 40) wait.
	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: procInstance hasFinalized.! !

BpmProcessExecutionTest subclass: #TaskTimerProcessExecutionTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!TaskTimerProcessExecutionTest2 commentStamp: '' prior: 0!
This is the same process test as TaskTimerProcessExecutionTest but with shorter Timers in order the test execute faster.!

!TaskTimerProcessExecutionTest2 methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:14'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForTimerTask_2. 

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'task_timer_2' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	^processGenerator getProcessDefinitionNamed: 'task_timer_2' ifNone: [self assert: false].! !

!TaskTimerProcessExecutionTest2 methodsFor: 'form instance' stamp: 'brunobb 11/02/2017 13:44'!
formInstance_set_timer_term_3

	^self createFormInstance: #form_set_timer_term_3 definitionNamed: 'set-timer-term' app: 'ue' definitionMethod: #formDefinition_set_timer_term! !

!TaskTimerProcessExecutionTest2 methodsFor: 'form instance' stamp: 'brunobb 11/02/2017 13:40'!
formInstance_user_form

	^self createFormInstance: #form_user_form_1 definitionNamed: 'user-form' app: 'ue' definitionMethod: #formDefinition_user_form! !

!TaskTimerProcessExecutionTest2 methodsFor: 'other' stamp: 'brunobb 11/02/2017 13:46'!
setUp

	super setUp.
	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'task_timer_2' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'andrew vm' put: (BpmUser getExistingOrNewUserNamed: 'andrew vm').

	(BpmFrontOfficeRole createNewOrGetExisting: 'timer-role' in: 'ue') grantUser: (users at: 'andrew vm').! !

!TaskTimerProcessExecutionTest2 methodsFor: 'test' stamp: 'brunobb 01/14/2018 10:32'!
testExecuteProcess_01
	| currentTask |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'andrew vm').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [set-timer-term]"

	currentTask := procInstance currentActivities last.

	self assert: (procInstance currentActivities size = 1).
	self assert: (procInstance currentActivities last attachedEvents size = 1).
	self assert: (currentTask getDefinitionName = 'set-timer-term').
	self assert: (self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) notEmpty.

	"formInstance_set_timer_term: is set with 15 seconds and this number is used by timer named Term to wait before finishing the process"
	"the attached event wait for 10 seconds and after that trigger a new transition"

	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_set_timer_term_3.  "15 seconds to wait"

	self assert: ((procInstance getEventsNamed: 'term' ifNone: [self assert: false]) size = 1).
	self assert: procInstance currentActivities isEmpty.

	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: procInstance currentActivities isEmpty.
	self assert: ((procInstance getEventsNamed: 'term' ifNone: [self assert: false]) size = 1).
	self deny: procInstance hasFinalized.
	self assert: (self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) notEmpty.

	(Delay forSeconds: 8) wait.
	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: procInstance currentActivities isEmpty.
	self assert: ((procInstance getEventsNamed: 'term' ifNone: [self assert: false]) size = 1).
	self deny: procInstance hasFinalized.
	self assert: (self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) notEmpty.

	(Delay forSeconds: 9) wait.
	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: procInstance hasFinalized.
	self assert: (self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) isEmpty.! !

!TaskTimerProcessExecutionTest2 methodsFor: 'test' stamp: 'brunobb 01/14/2018 10:40'!
testExecuteProcess_02
	"formInstance_set_timer_term: is set with 15 seconds and this number is used by timer named Term to wait before finishing the process"
	"the attached event wait for 10 seconds and after that trigger a new transition"
	| currentTask |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'andrew vm').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [set-timer-term]"

	currentTask := procInstance currentActivities last.

	self assert: (procInstance currentActivities size = 1).
	self assert: (procInstance currentActivities last attachedEvents size = 1).
	self assert: (currentTask getDefinitionName = 'set-timer-term').
	self assert: ((self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) size = 1).

	(Delay forSeconds: 5) wait.
	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: (procInstance currentActivities size = 1).
	self assert: (procInstance currentActivities last attachedEvents size = 1).
	self assert: (currentTask getDefinitionName = 'set-timer-term').
	self assert: ((self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) size = 1).

	(Delay forSeconds: 7) wait.
	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: (procInstance currentActivities size = 2).
	self assert: ((self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) size = 1).

	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_set_timer_term_3. "15 seconds to wait"

	self assert: ((self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) size = 1).
	self assert: (procInstance currentActivities size = 1).
	self assert: ((procInstance getEventsNamed: 'term' ifNone: [self assert: false]) size = 1).
	self deny: procInstance hasFinalized.

	(Delay forSeconds: 18) wait.
	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: procInstance hasFinalized.
	self assert: (procInstance currentActivities size = 1).
	self assert: (self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) isEmpty.! !

!TaskTimerProcessExecutionTest2 methodsFor: 'test' stamp: 'brunobb 01/14/2018 10:48'!
testExecuteProcess_03
	"formInstance_set_timer_term: is set with 15 seconds and this number is used by timer named Term to wait before finishing the process"
	"the attached event wait for 10 seconds and after that trigger a new transition"
	| currentTask |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'andrew vm').

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [set-timer-term]"

	currentTask := procInstance currentActivities last.

	self assert: (procInstance currentActivities size = 1).
	self assert: (procInstance currentActivities last attachedEvents size = 1).
	self assert: (currentTask getDefinitionName = 'set-timer-term').
	self assert: ((self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) size = 1).

	(Delay forSeconds: 5) wait.
	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: (procInstance currentActivities size = 1).
	self assert: (procInstance currentActivities last attachedEvents size = 1).
	self assert: (currentTask getDefinitionName = 'set-timer-term').
	self assert: ((self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) size = 1).

	(Delay forSeconds: 7) wait.
	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: (procInstance currentActivities size = 2).
	self deny: procInstance hasFinalized.
	self assert: ((self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) size = 1).
	(Delay forSeconds: 12) wait.
	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: (procInstance currentActivities size = 3). "two [user-form] tasks"
	currentTask := procInstance currentActivities first.

	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_set_timer_term_3. "15 seconds to wait"

	self assert: ((procInstance getEventsNamed: 'term' ifNone: [self assert: false]) size = 1).
	self assert: ((self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) size = 1).
	(Delay forSeconds: 18) wait.
	self defaultTimerEventMonitor triggerArtifactTimers.
	self assert: ((self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) size = 0).
	self assert: ((procInstance getEventsNamed: 'term' ifNone: [self assert: false]) size = 1).
	self assert: procInstance hasFinalized.
	self assert: (procInstance currentActivities size = 2).! !

!TaskTimerProcessExecutionTest2 methodsFor: 'test' stamp: 'brunobb 01/14/2018 18:25'!
testExecuteProcessAbort_01
	"formInstance_set_timer_term: is set with 15 seconds and this number is used by timer named Term to wait before finishing the process"
	"the attached event wait for 10 seconds and after that trigger a new transition"
	| currentTask processId currentProcessMatrix finishedProcessMatrix |

	procInstance := procDefinition createAndStartProcessInstance: (self getUserNamed: 'andrew vm').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.

	self assert: (procInstance startEvent getDefinitionName = 'start').
	"Step 1 - Form [set-timer-term]"

	currentTask := procInstance currentActivities last.

	self assert: (procInstance currentActivities size = 1).
	self assert: (procInstance currentActivities last attachedEvents size = 1).
	self assert: (currentTask getDefinitionName = 'set-timer-term').
	self assert: (self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) notEmpty.

	self assert: (currentProcessMatrix getAvailableTasksFor: 'timer-role' satisfying: {:assign | assign.processId = processId}) notEmpty.

	procInstance abortProcess: nil.
	procInstance currentState isConfirmed: true. 
	procInstance confirmAbortion.

	self assert: (self defaultTimerEventMonitor monitoredEvents select: [:each | each processId = procInstance processId]) isEmpty.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'timer-role' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: (finishedProcessMatrix getAvailableTasksFor: 'timer-role' satisfying: {:assign | assign.processId = processId}) isEmpty.! !

BpmProcessExecutionTest subclass: #TimerProcessExecutionStartSimpleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!TimerProcessExecutionStartSimpleTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:14'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForTimerProcessStartSimple. 

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'timer-process-start-simple' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	^processGenerator getProcessDefinitionNamed: 'timer-process-start-simple' ifNone: [self assert: false].! !

!TimerProcessExecutionStartSimpleTest methodsFor: 'other' stamp: 'brunobb 08/24/2017 10:25'!
setUp

	super setUp.
	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'timer-process-start-simple' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'andrew vm' put: (BpmUser getExistingOrNewUserNamed: 'andrew vm').

	(BpmFrontOfficeRole createNewOrGetExisting: 'executer' in: 'ue') grantUser: (users at: 'andrew vm').! !

!TimerProcessExecutionStartSimpleTest methodsFor: 'test' stamp: 'brunobb 08/24/2017 10:27'!
testProcessCreation

	self assert: true! !

BpmProcessExecutionTest subclass: #TimerProcessExecutionStartTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!TimerProcessExecutionStartTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:14'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForTimerProcessStart. 

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'timer-process-start' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	^processGenerator getProcessDefinitionNamed: 'timer-process-start' ifNone: [self assert: false].! !

!TimerProcessExecutionStartTest methodsFor: 'other' stamp: 'brunobb 08/10/2017 13:32'!
setUp

	super setUp.
	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'timer-process-start' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'andrew vm' put: (BpmUser getExistingOrNewUserNamed: 'andrew vm').

	(BpmFrontOfficeRole createNewOrGetExisting: 'executer' in: 'ue') grantUser: (users at: 'andrew vm').! !

!TimerProcessExecutionStartTest methodsFor: 'test' stamp: 'brunobb 08/10/2017 13:30'!
testProcessCreation

	self assert: true! !

BpmProcessExecutionTest subclass: #TimerProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!TimerProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:15'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForTimerProcess. 

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'timer-process' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	^processGenerator getProcessDefinitionNamed: 'timer-process' ifNone: [self assert: false].! !

!TimerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/09/2017 14:07'!
setUp

	super setUp.
	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'timer-process' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].

	users at: 'andrew vm' put: (BpmUser getExistingOrNewUserNamed: 'andrew vm').

	(BpmFrontOfficeRole createNewOrGetExisting: 'executer' in: 'ue') grantUser: (users at: 'andrew vm').! !

!TimerProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/03/2017 08:08'!
testProcessCreation

	self assert: true! !

BpmProcessExecutionTest subclass: #VisaApplianceProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!VisaApplianceProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 12/10/2017 18:15'!
createProcessDefinition
	| xpdlReader processGenerator |

	xpdlReader := XPDLProcessDefinitionTemplate xpdlReaderForVisaProcess.

	processGenerator := BpmProcessGenerator on: xpdlReader xpdlPackages.
	processGenerator mapProcess: 'visa-appliance' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		mapProcess: 'home-office-check' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		mapProcess: 'check-financial-data' toApplication: (self getOrbeonApplicationClass getExistingApplicationOrCreateNewNamed: 'ue');
		generateAllProcess.

	processGenerator processes do: [:each | each addToCache].

	^processGenerator getProcessDefinitionNamed: 'visa-appliance' ifNone: [self assert: false].! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/15/2016 10:04'!
formInstance_analyze_appliance

	^self createFormInstance: #form_analyze_appliance_1 definitionNamed: 'analyze-appliance' app: 'ue' definitionMethod: #formDefinition_analyze_appliance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/15/2016 10:04'!
formInstance_analyze_appliance_2

	^self createFormInstance: #form_analyze_appliance_2 definitionNamed: 'analyze-appliance' app: 'ue' definitionMethod: #formDefinition_analyze_appliance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'brunobb 02/01/2018 13:15'!
formInstance_analyze_appliance: aBpmProcessInstance

	^self createFormInstance: #form_analyze_appliance_1 
			definitionNamed: 'analyze-appliance' 
			app: 'ue' 
			definitionMethod: #formDefinition_analyze_appliance
			in: aBpmProcessInstance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'brunobb 01/04/2018 13:07'!
formInstance_applicant_home_office_report: aBpmProcessInstance

	^self createFormInstance: #form_applicant_home_office_report_1 
			definitionNamed: 'applicant-home-office-report' 
			app: 'ue' definitionMethod: #formDefinition_applicant_home_office_report
			in: aBpmProcessInstance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'brunobb 01/05/2018 12:07'!
formInstance_check_accounts: aBpmProcessInstance

	^self createFormInstance: #form_check_accounts_1 
			definitionNamed: 'check-accounts' 
			app: 'ue' 
			definitionMethod: #formDefinition_check_accounts
			in: aBpmProcessInstance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'brunobb 01/04/2018 13:07'!
formInstance_check_applicant_record: aBpmProcessInstance

	^self createFormInstance: #form_check_applicant_record_1 
			definitionNamed: 'check-applicant-record' 
			app: 'ue' 
			definitionMethod: #formDefinition_check_applicant_record
			in: aBpmProcessInstance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/15/2016 10:05'!
formInstance_check_basic_data

	^self createFormInstance: #form_check_basic_data_1 definitionNamed: 'check-basic-data' app: 'ue' definitionMethod: #formDefinition_check_basic_data! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/15/2016 10:13'!
formInstance_check_basic_data_2

	^self createFormInstance: #form_check_basic_data_2 definitionNamed: 'check-basic-data' app: 'ue' definitionMethod: #formDefinition_check_basic_data! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'brunobb 02/01/2018 13:12'!
formInstance_check_basic_data: aBpmProcessInstance

	^self createFormInstance: #form_check_basic_data_1 
			definitionNamed: 'check-basic-data' 
			app: 'ue' 
			definitionMethod: #formDefinition_check_basic_data
			in: aBpmProcessInstance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'brunobb 01/05/2018 12:08'!
formInstance_check_debts: aBpmProcessInstance

	^self createFormInstance: #form_check_debts_1 
			definitionNamed: 'check-debts' 
			app: 'ue' 
			definitionMethod: #formDefinition_check_debts
			in: aBpmProcessInstance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/15/2016 10:14'!
formInstance_check_previous_appliance

	^self createFormInstance: #form_check_previous_appliance_1 definitionNamed: 'check-previous-appliance' app: 'ue' definitionMethod: #formDefinition_check_previous_appliance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'brunobb 02/01/2018 13:14'!
formInstance_check_previous_appliance: aBpmProcessInstance

	^self createFormInstance: #form_check_previous_appliance_1 
			definitionNamed: 'check-previous-appliance' 
			app: 'ue' 
			definitionMethod: #formDefinition_check_previous_appliance
			in: aBpmProcessInstance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'brunobb 01/05/2018 12:08'!
formInstance_check_properties: aBpmProcessInstance

	^self createFormInstance: #form_check_properties_1 
			definitionNamed: 'check-properties' 
			app: 'ue' 
			definitionMethod: #formDefinition_check_properties
			in: aBpmProcessInstance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/15/2016 10:14'!
formInstance_citizen_appliance

	^self createFormInstance: #form_citizen_appliance_1 definitionNamed: 'citizen-appliance' app: 'ue' definitionMethod: #formDefinition_citizen_appliance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'brunobb 02/01/2018 13:11'!
formInstance_citizen_appliance: aBpmProcessInstance

	^self createFormInstance: #form_citizen_appliance_1 
			definitionNamed: 'citizen-appliance' 
			app: 'ue' 
			definitionMethod: #formDefinition_citizen_appliance
			in: aBpmProcessInstance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'BrunoBB 07/15/2016 10:15'!
formInstance_emit_visa

	^self createFormInstance: #form_emit_visa_1 definitionNamed: 'emit-visa' app: 'ue' definitionMethod: #formDefinition_emit_visa! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'brunobb 02/01/2018 13:16'!
formInstance_emit_visa: aBpmProcessInstance

	^self createFormInstance: #form_emit_visa_1 
			definitionNamed: 'emit-visa' 
			app: 'ue' 
			definitionMethod: #formDefinition_emit_visa
			in: aBpmProcessInstance! !

!VisaApplianceProcessExecutionTest methodsFor: 'form instances' stamp: 'brunobb 01/05/2018 12:09'!
formInstance_financial_report: aBpmProcessInstance

	^self createFormInstance: #form_financial_report_1 
			definitionNamed: 'financial-report' 
			app: 'ue' 
			definitionMethod: #formDefinition_financial_report
			in: aBpmProcessInstance! !

!VisaApplianceProcessExecutionTest methodsFor: 'execution and test' stamp: 'brunobb 02/01/2018 13:13'!
resumeFromTask2AndTestProcess: aBpmProcessInstance
	"The receiver resume the execution of <aBpmProcessInstance> from the <aBpmTaskInstance> number 2 and finish it execution"
	| currentTask currentProcessMatrix finishedProcessMatrix processId |

	processId := aBpmProcessInstance id.
	currentProcessMatrix := aBpmProcessInstance getProcessMatrix.
	finishedProcessMatrix := aBpmProcessInstance getFinishedProcessMatrix.

	"Step 2 - Form [check-basic-data]"
	currentTask :=  aBpmProcessInstance currentActivities last.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: (self formInstance_check_basic_data: aBpmProcessInstance).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 2).

	self resumeFromTask3AndTestProcess: aBpmProcessInstance.! !

!VisaApplianceProcessExecutionTest methodsFor: 'execution and test' stamp: 'brunobb 02/01/2018 13:16'!
resumeFromTask3AndTestProcess: aBpmProcessInstance
	"The receiver resume the execution of <aBpmProcessInstance> from the <aBpmTaskInstance> number 2 and finish it execution"
	| currentTask gateway endArtifact subProcessL1 subProcessL2 processId currentProcessMatrix finishedProcessMatrix subProcId subProcCurrentMatrix subProcFinishedMatrix subProc2CurrentMatrix subProc2FinishedMatrix subProc2Id |

	processId := aBpmProcessInstance id.
	currentProcessMatrix := aBpmProcessInstance getProcessMatrix.
	finishedProcessMatrix := aBpmProcessInstance getFinishedProcessMatrix.

	"Step 3 - Gateway Evaluation"
	gateway := aBpmProcessInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'accept basic data').

	"Step 4 - Form [check-previous-appliance]"
	currentTask := aBpmProcessInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: (self formInstance_check_previous_appliance: aBpmProcessInstance).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 1).

	"Sub Process Execution [home-office-check] starts here "
		subProcessL1 := aBpmProcessInstance subprocesses last.
		subProcId := subProcessL1 id.
		subProcCurrentMatrix := subProcessL1 getProcessMatrix.
		subProcFinishedMatrix := subProcessL1 getFinishedProcessMatrix.

		self assert: (aBpmProcessInstance includesSubProcess: subProcessL1).
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start visa check').

		"Step 1 [subproc] - Form [check-applicant-record]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'check-applicant-record').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_check_applicant_record: subProcessL1) on: subProcessL1.
		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 1).


		"Step 2 [subproc] - Form [applicant-home-office-report]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'applicant-home-office-report').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_applicant_home_office_report: subProcessL1) on: subProcessL1.
		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 2).
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.

		"Sub Process Execution [check-financial-data]"
			subProcessL2 := subProcessL1 subprocesses last.
			subProc2Id := subProcessL2 id.
			subProc2CurrentMatrix := subProcessL2 getProcessMatrix.
			subProc2FinishedMatrix := subProcessL2 getFinishedProcessMatrix.
			self assert: (subProcessL1 includesSubProcess: subProcessL2).
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start financial check').

			"Step 1 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-accounts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_check_accounts: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 2 [subproc] - Form [check-properties]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-properties').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew po' withForm: (self formInstance_check_properties: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 3 [subproc] - Form [check-debts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-debts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew do' withForm: (self formInstance_check_debts: subProcessL2).
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 4 [subproc] - Form [financial-report]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'financial-report').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_financial_report: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 2).
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.

			"Sub Process [check-financial-data] ends and gives control to previous process"
		"Sub Process [check-applicant-record] ends and gives control to main process"

	"Top Process [visa-appliance] resume execution "

	"Step 5 - Form [analyze-appliance]"
	currentTask := aBpmProcessInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'analyze-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: (self formInstance_analyze_appliance: aBpmProcessInstance).
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 2).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.

	"Step 6 - Gateway Evaluation"
	gateway := aBpmProcessInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'granted').

	"Step 7 - Form [emit-visa]"
	currentTask := aBpmProcessInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'emit-visa').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: (self formInstance_emit_visa: aBpmProcessInstance).
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 3).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.

	endArtifact := aBpmProcessInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'visa apply end') and: [endArtifact isEndEvent]).! !

!VisaApplianceProcessExecutionTest methodsFor: 'other' stamp: 'brunobb 01/30/2018 13:45'!
setUp

	super setUp.
	users := Dictionary new.

	procDefinition := BpmProcessDefinition getAllProcessesNamed: 'visa-appliance' in: 'ue'. "answer a collection with all versions"
	
	procDefinition := procDefinition ifEmpty: [self createProcessDefinition] ifNotEmpty: [:collection | collection last].
	procDefinition assignationPolicy: (BpmNoneAssignationPolicy newOn: procDefinition). 

	users at: 'andrew vo' put: (BpmUser getExistingOrNewUserNamed: 'andrew vo').
	users at: 'andrew vm' put: (BpmUser getExistingOrNewUserNamed: 'andrew vm').
	users at: 'andrew vc' put: (BpmUser getExistingOrNewUserNamed: 'andrew vc').
	users at: 'andrew fo' put: (BpmUser getExistingOrNewUserNamed: 'andrew fo').
	users at: 'andrew po' put: (BpmUser getExistingOrNewUserNamed: 'andrew po').
	users at: 'andrew do' put: (BpmUser getExistingOrNewUserNamed: 'andrew do').

	(BpmFrontOfficeRole getRoleNamed: 'visa officer' in: 'ue') grantUser: (users at: 'andrew vo').
	(BpmFrontOfficeRole getRoleNamed: 'visa manager' in: 'ue') grantUser: (users at: 'andrew vm').
	(BpmFrontOfficeRole getRoleNamed: 'visa checker' in: 'ue') grantUser: (users at: 'andrew vc').
	(BpmFrontOfficeRole getRoleNamed: 'finance officer' in: 'ue') grantUser: (users at: 'andrew fo').
	(BpmFrontOfficeRole getRoleNamed: 'properties officer' in: 'ue') grantUser: (users at: 'andrew po').
	(BpmFrontOfficeRole getRoleNamed: 'debts officer' in: 'ue') grantUser: (users at: 'andrew do').! !

!VisaApplianceProcessExecutionTest methodsFor: 'execution and test' stamp: 'brunobb 02/01/2018 09:50'!
startFinishAndTestProcess: aBpmProcessInstance
	"The receiver start the execution of the new created <aBpmProcessInstance> and finish it execution"
	| currentTask processId currentProcessMatrix finishedProcessMatrix |

	self assert: (aBpmProcessInstance startEvent getDefinitionName = 'visa apply start').
	processId := aBpmProcessInstance id.
	currentProcessMatrix := aBpmProcessInstance getProcessMatrix.
	finishedProcessMatrix := aBpmProcessInstance getFinishedProcessMatrix.

	"Step 1 - Form [citizen-appliance]"
	currentTask := aBpmProcessInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 1).

	self resumeFromTask2AndTestProcess: aBpmProcessInstance.! !

!VisaApplianceProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 03/26/2016 15:51'!
tearDown

	"procInstance definition removeProcessInstance: procInstance"! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 02/01/2018 14:21'!
test_roundRobinRole_visaAccepted
	"Testing Assignation Policy Round Robin by Role"
	| newRoundRobinProcesses availableUsers assignations assignmentsInProcess |

	users at: 'andrew vo2' put: (BpmUser getExistingOrNewUserNamed: 'andrew vo2').
	users at: 'andrew vo3' put: (BpmUser getExistingOrNewUserNamed: 'andrew vo3').
	(BpmFrontOfficeRole getRoleNamed: 'visa officer' in: 'ue') removeAllUsers.
	(BpmFrontOfficeRole getRoleNamed: 'visa officer' in: 'ue') grantUser: (users at: 'andrew vo').
	(BpmFrontOfficeRole getRoleNamed: 'visa officer' in: 'ue') grantUser: (users at: 'andrew vo2').
	(BpmFrontOfficeRole getRoleNamed: 'visa officer' in: 'ue') grantUser: (users at: 'andrew vo3').

	procDefinition assignationPolicy: (BpmRoundRobinRoleAssignationPolicy newOn: procDefinition). "new assignation policy is created here (all user has count := 0)"
	procDefinition assignationPolicy isAutomatic: true. 

	newRoundRobinProcesses := OrderedCollection new.
	availableUsers := (BpmFrontOfficeRole getRoleNamed: 'visa officer' in: 'ue') users asOrderedCollection. 

	self assert: (procDefinition assignationPolicy assignments allSatisfy: [:eachCount | eachCount count = 0]). 

	1 to: 10 do: [:index | | newProcess |
		newProcess := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').
		newRoundRobinProcesses add: newProcess.
	].

	assignations := procDefinition assignationPolicy assignments at: 'visa officer'. "answer <aSortedCollection>"

	self assert: ((assignations select: [:each | each count = 3]) size = 2).
	self assert: ((assignations select: [:each | each count = 4]) size = 1).

	assignmentsInProcess := (users at: 'andrew vo') getCurrentAssignments select: [:each | newRoundRobinProcesses identityIncludes: each process].
	self assert: ((assignmentsInProcess size = 3) or: [assignmentsInProcess size = 4]).
	assignmentsInProcess := (users at: 'andrew vo2') getCurrentAssignments select: [:each | newRoundRobinProcesses identityIncludes: each process].
	self assert: ((assignmentsInProcess size = 3) or: [assignmentsInProcess size = 4]).
	assignmentsInProcess := (users at: 'andrew vo3') getCurrentAssignments select: [:each | newRoundRobinProcesses identityIncludes: each process].
	self assert: ((assignmentsInProcess size = 3) or: [assignmentsInProcess size = 4]).

	self assert: ((users at: 'andrew vo') getCurrentAssignments anySatisfy: [:each | (users at: 'andrew vo2') getCurrentAssignments identityIncludes: each]) not. 
	self assert: ((users at: 'andrew vo') getCurrentAssignments anySatisfy: [:each | (users at: 'andrew vo3') getCurrentAssignments identityIncludes: each]) not. 
	self assert: ((users at: 'andrew vo2') getCurrentAssignments anySatisfy: [:each | (users at: 'andrew vo3') getCurrentAssignments identityIncludes: each]) not. 

	"Here we send all 10 processes to the second task <check-basic-data> by finalizing current task <citizen-appliance> "
	"Step 1 - Form [citizen-appliance]" 
	((users at: 'andrew vo') getCurrentAssignments select: [:each | (newRoundRobinProcesses identityIncludes: each process) and:[each taskName = 'citizen-appliance']]) do: [:assignment | 
		self associate: assignment withForm: (self formInstance_citizen_appliance: assignment process) on: assignment process.
		self finalizeAssignment: assignment withUserNamed: 'andrew vo' on: assignment process.
	].
	((users at: 'andrew vo2') getCurrentAssignments select: [:each | (newRoundRobinProcesses identityIncludes: each process) and:[each taskName = 'citizen-appliance']]) do: [:assignment | 
		self associate: assignment withForm: (self formInstance_citizen_appliance: assignment process) on: assignment process.
		self finalizeAssignment: assignment withUserNamed: 'andrew vo2' on: assignment process.
	].
	((users at: 'andrew vo3') getCurrentAssignments select: [:each | (newRoundRobinProcesses identityIncludes: each process) and:[each taskName = 'citizen-appliance']]) do: [:assignment | 
		self associate: assignment  withForm: (self formInstance_citizen_appliance: assignment process) on: assignment process.
		self finalizeAssignment: assignment withUserNamed: 'andrew vo3' on: assignment process.
	].

	self assert: ((assignations select: [:each | each count = 6]) size = 1).
	self assert: ((assignations select: [:each | each count = 7]) size = 2).

	"here we compare with 2,3 and 4. 2 is also used because first distribution can be 3,3,4 and the second 4,4,2 "
	assignmentsInProcess := (users at: 'andrew vo') getCurrentAssignments select: [:each | newRoundRobinProcesses identityIncludes: each process].
	self assert: ((assignmentsInProcess size = 2) or: [(assignmentsInProcess size = 3) or: [assignmentsInProcess size = 4]]).
	assignmentsInProcess := (users at: 'andrew vo2') getCurrentAssignments select: [:each | newRoundRobinProcesses identityIncludes: each process].
	self assert: ((assignmentsInProcess size = 2) or: [(assignmentsInProcess size = 3) or: [assignmentsInProcess size = 4]]).
	assignmentsInProcess := (users at: 'andrew vo3') getCurrentAssignments select: [:each | newRoundRobinProcesses identityIncludes: each process].
	self assert: ((assignmentsInProcess size = 2) or: [(assignmentsInProcess size = 3) or: [assignmentsInProcess size = 4]]).

	newRoundRobinProcesses do: [:procInst | self resumeFromTask2AndTestProcess: procInst]! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 01/30/2018 13:45'!
testExecuteProcess_issue_366
	"Test the github issue #366 for recursive search for a field value
	Go to the last asserts in this method"
	| currentTask gateway endArtifact subProcessL1 subProcessL2 processId currentProcessMatrix finishedProcessMatrix subProcId subProcCurrentMatrix subProcFinishedMatrix subProc2CurrentMatrix subProc2FinishedMatrix subProc2Id |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.

	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 1).

	"Step 2 - Form [check-basic-data]"
	currentTask :=  procInstance currentActivities last.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 2).

	"Step 3 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'accept basic data').

	"Step 4 - Form [check-previous-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_check_previous_appliance.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 1).

	"Sub Process Execution [home-office-check] starts here "
		subProcessL1 := procInstance subprocesses last.
		subProcId := subProcessL1 id.
		subProcCurrentMatrix := subProcessL1 getProcessMatrix.
		subProcFinishedMatrix := subProcessL1 getFinishedProcessMatrix.

		self assert: (procInstance includesSubProcess: subProcessL1).
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start visa check').

		"Step 1 [subproc] - Form [check-applicant-record]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'check-applicant-record').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_check_applicant_record: subProcessL1) on: subProcessL1.
		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 1).


		"Step 2 [subproc] - Form [applicant-home-office-report]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'applicant-home-office-report').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_applicant_home_office_report: subProcessL1) on: subProcessL1.
		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 2).
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.

		"Sub Process Execution [check-financial-data]"
			subProcessL2 := subProcessL1 subprocesses last.
			subProc2Id := subProcessL2 id.
			subProc2CurrentMatrix := subProcessL2 getProcessMatrix.
			subProc2FinishedMatrix := subProcessL2 getFinishedProcessMatrix.
			self assert: (subProcessL1 includesSubProcess: subProcessL2).
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start financial check').

			"Step 1 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-accounts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_check_accounts: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 2 [subproc] - Form [check-properties]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-properties').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew po' withForm: (self formInstance_check_properties: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 3 [subproc] - Form [check-debts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-debts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew do' withForm: (self formInstance_check_debts: subProcessL2).
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 4 [subproc] - Form [financial-report]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'financial-report').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_financial_report: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 2).
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.

			"Sub Process [check-financial-data] ends and gives control to previous process"
		"Sub Process [check-applicant-record] ends and gives control to main process"

	"Top Process [visa-appliance] resume execution "

	"Step 5 - Form [analyze-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'analyze-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_analyze_appliance.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 2).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.

	"Step 6 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'granted').

	"Step 7 - Form [emit-visa]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'emit-visa').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_emit_visa.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 3).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.

	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'visa apply end') and: [endArtifact isEndEvent]).

	self assert: ((procInstance getValueOfProcessField: 'non-existent-field') = nil).
	self assert: ((procInstance getValueOfProcessField: 'non-existent-field[i]') = nil).
	self assert: ((procInstance getValueOfProcessField: 'hello-field') = nil).
	self assert: ((procInstance getValuesOfProcessField: 'citizenName') includes: 'Jorge').
	self assert: ((procInstance getValuesOfProcessField: 'citizenName') includes: 'Ceci').
	self assert: ((procInstance getValuesOfProcessField: 'citizenName') includes: 'Bruno').

	self assert: ((procInstance getValuesOfProcessField: 'citizenPhone') includes: '999106087').
	self assert: ((procInstance getValuesOfProcessField: 'citizenPhone') includes: '999789654').

	"this is a repeatable field --> we get the collection directly with #getValueOfProcessField:"
	self assert: ((procInstance getValueOfProcessField: 'assetType') includes: 'debt'). 
	self assert: ((procInstance getValueOfProcessField: 'assetValue') includes: 300000).
	self assert: ((procInstance getValueOfProcessField: 'assetType') includes: 'bank-accout').
	self assert: ((procInstance getValueOfProcessField: 'assetValue') includes: 600000).
	self assert: ((procInstance getValueOfProcessField: 'assetType') includes: 'bank-accout').
	self assert: ((procInstance getValueOfProcessField: 'assetValue') includes: 50000).
	self assert: ((procInstance getValueOfProcessField: 'assetType') includes: 'bank-accout').
	self assert: ((procInstance getValueOfProcessField: 'assetValue') includes: 900000).! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 02/01/2018 11:31'!
testExecuteProcess_issue_373
	| currentTask assignment gateway endArtifact subProcessL1 subProcessL2 processId currentProcessMatrix finishedProcessMatrix subProcId subProcCurrentMatrix subProcFinishedMatrix subProc2CurrentMatrix subProc2FinishedMatrix subProc2Id |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.

	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.

	assignment := self takeTask: currentTask forUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance on: procInstance.

	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((users at: 'andrew vo') getCurrentAssignments select: [:each | each processId = processId]) notEmpty.
	
	(BpmFrontOfficeRole getRoleNamed: 'visa officer' in: 'ue') ungrantUser: (users at: 'andrew vo').

	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self assert: ((users at: 'andrew vo') getCurrentAssignments select: [:each | each processId = processId]) isEmpty.

	(BpmFrontOfficeRole getRoleNamed: 'visa officer' in: 'ue') grantUser: (users at: 'andrew vo').
	(users at: 'andrew vo') take: assignment.

	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((users at: 'andrew vo') getCurrentAssignments select: [:each | each processId = processId]) notEmpty.

	self finalizeAssignment: assignment withUserNamed: 'andrew vo' on: procInstance.

	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 1).

	"Step 2 - Form [check-basic-data]"
	currentTask :=  procInstance currentActivities last.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 2).

	"Step 3 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'accept basic data').

	"Step 4 - Form [check-previous-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_check_previous_appliance.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 1).

	"Sub Process Execution [home-office-check] starts here "
		subProcessL1 := procInstance subprocesses last.
		subProcId := subProcessL1 id.
		subProcCurrentMatrix := subProcessL1 getProcessMatrix.
		subProcFinishedMatrix := subProcessL1 getFinishedProcessMatrix.

		self assert: (procInstance includesSubProcess: subProcessL1).
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start visa check').

		"Step 1 [subproc] - Form [check-applicant-record]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'check-applicant-record').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_check_applicant_record: subProcessL1) on: subProcessL1.
		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 1).


		"Step 2 [subproc] - Form [applicant-home-office-report]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'applicant-home-office-report').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_applicant_home_office_report: subProcessL1) on: subProcessL1.
		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 2).
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.

		"Sub Process Execution [check-financial-data]"
			subProcessL2 := subProcessL1 subprocesses last.
			subProc2Id := subProcessL2 id.
			subProc2CurrentMatrix := subProcessL2 getProcessMatrix.
			subProc2FinishedMatrix := subProcessL2 getFinishedProcessMatrix.
			self assert: (subProcessL1 includesSubProcess: subProcessL2).
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start financial check').

			"Step 1 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-accounts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_check_accounts: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 2 [subproc] - Form [check-properties]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-properties').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew po' withForm: (self formInstance_check_properties: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 3 [subproc] - Form [check-debts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-debts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew do' withForm: (self formInstance_check_debts: subProcessL2).
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 4 [subproc] - Form [financial-report]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'financial-report').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_financial_report: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 2).
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.

			"Sub Process [check-financial-data] ends and gives control to previous process"
		"Sub Process [check-applicant-record] ends and gives control to main process"

	"Top Process [visa-appliance] resume execution "

	"Step 5 - Form [analyze-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'analyze-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_analyze_appliance.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 2).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.

	"Step 6 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'granted').

	"Step 7 - Form [emit-visa]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'emit-visa').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_emit_visa.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 3).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.

	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'visa apply end') and: [endArtifact isEndEvent]).! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 01/30/2018 13:45'!
testExecuteProcess_visaAborted_01
	| currentTask currentProcessMatrix finishedProcessMatrix processId |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.
	"Step 2 - Form [check-basic-data]"
	currentTask :=  procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.

	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenName[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenSurname[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	"here the process is cancelled"
	procInstance abortProcess: nil.
	procInstance currentState isConfirmed: true. 
	procInstance confirmAbortion.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: (finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: (procDefinition hasAbortedProcess: processId).
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenName[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenSurname[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 01/30/2018 13:45'!
testExecuteProcess_visaAborted_02
	| currentTask gateway currentProcessMatrix finishedProcessMatrix processId |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.

	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.

	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenName[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenSurname[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	"Step 2 - Form [check-basic-data]"
	currentTask :=  procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.

	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data.

	self assert: ((procDefinition getCollectionForFieldsNamed: 'originCountry[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'gender[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	"Step 3 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'accept basic data').

	"Step 4 - Form [check-previous-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.

	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 2).

	"here the process is cancelled"
	procInstance abortProcess: nil.
	procInstance currentState isConfirmed: true. 
	procInstance confirmAbortion.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: (finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: (procDefinition hasAbortedProcess: processId).
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenName[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenSurname[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'originCountry[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'gender[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) isEmpty.! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 01/09/2018 15:10'!
testExecuteProcess_visaAborted_03
	| currentTask gateway subProcessL1 subProcessL2 processId currentProcessMatrix finishedProcessMatrix subProcId subProcCurrentMatrix subProcFinishedMatrix subProc2CurrentMatrix subProc2FinishedMatrix subProc2Id |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.

	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.

	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.

	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 1).
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenName[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenSurname[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	"Step 2 - Form [check-basic-data]"
	currentTask :=  procInstance currentActivities last.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self assert: (currentTask getDefinitionName = 'check-basic-data').

	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data.

	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 2).
	self assert: ((procDefinition getCollectionForFieldsNamed: 'originCountry[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'gender[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	"Step 3 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'accept basic data').

	"Step 4 - Form [check-previous-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.

	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_check_previous_appliance.

	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 1).
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenId[n]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'expirationDate[d]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.

	"Sub Process Execution [home-office-check] starts here "
		subProcessL1 := procInstance subprocesses last.
		subProcId := subProcessL1 id.
		subProcCurrentMatrix := subProcessL1 getProcessMatrix.
		subProcFinishedMatrix := subProcessL1 getFinishedProcessMatrix.

		self assert: (procInstance includesSubProcess: subProcessL1).
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start visa check').

		"Step 1 [subproc] - Form [check-applicant-record]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'check-applicant-record').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.

		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_check_applicant_record: subProcessL1) on: subProcessL1.

		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 1).
		self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'checkApplicantRecord[s]' in: 'check-applicant-record') select: [:fieldValue | fieldValue processId = subProcId]) notEmpty.

		"Step 2 [subproc] - Form [applicant-home-office-report]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'applicant-home-office-report').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.

		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_applicant_home_office_report: subProcessL1) on: subProcessL1.

		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 2).
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
		self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'offenseDate[d]' in: 'applicant-home-office-report') select: [:fieldValue | fieldValue processId = subProcId]) notEmpty.
		self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'offenseExpiration[d]' in: 'applicant-home-office-report') select: [:fieldValue | fieldValue processId = subProcId]) notEmpty.

		"Sub Process Execution [check-financial-data]"
			subProcessL2 := subProcessL1 subprocesses last.
			subProc2Id := subProcessL2 id.
			subProc2CurrentMatrix := subProcessL2 getProcessMatrix.
			subProc2FinishedMatrix := subProcessL2 getFinishedProcessMatrix.
			self assert: (subProcessL1 includesSubProcess: subProcessL2).
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start financial check').

			"Step 1 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-accounts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.

			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_check_accounts: subProcessL2) on: subProcessL2.

			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).
			self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'accountsDetails[s]' in: 'check-accounts') select: [:fieldValue | fieldValue processId = subProc2Id]) notEmpty.
			"Step 2 [subproc] - Form [check-properties]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-properties').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.

			self processTask: currentTask withUserNamed: 'andrew po' withForm: (self formInstance_check_properties: subProcessL2) on: subProcessL2.

			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).
			self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'propertiesDetails[s]' in: 'check-properties') select: [:fieldValue | fieldValue processId = subProc2Id]) notEmpty.
			"Step 3 [subproc] - Form [check-debts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-debts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.

			self processTask: currentTask withUserNamed: 'andrew do' withForm: (self formInstance_check_debts: subProcessL2).

			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).
			self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'debtsDetails[s]' in: 'check-debts') select: [:fieldValue | fieldValue processId = subProc2Id]) notEmpty.
			"Step 4 [subproc] - Form [financial-report]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'financial-report').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.

			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_financial_report: subProcessL2) on: subProcessL2.

			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 2).
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'assetValue[n]' in: 'financial-report') select: [:fieldValue | fieldValue processId = subProc2Id]) notEmpty.
			self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'assetType[s]' in: 'financial-report') select: [:fieldValue | fieldValue processId = subProc2Id]) notEmpty.
			"Sub Process [check-financial-data] ends and gives control to previous process"
		"Sub Process [check-applicant-record] ends and gives control to main process"

	"Top Process [visa-appliance] resume execution "

	"Step 5 - Form [analyze-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'analyze-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_analyze_appliance.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 2).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.

	"Step 6 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'granted').

	"Step 7 - Form [emit-visa]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'emit-visa').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.

	"here the process is cancelled"
	procInstance abortProcess: nil.
	procInstance currentState isConfirmed: true. 
	procInstance confirmAbortion.

	self assert: (procDefinition hasAbortedProcess: processId).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: (finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: (finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.

	self assert: (subProcessL1 definition hasAbortedProcess: subProcId).
	self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
	self assert: (subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.

	self assert: (subProcessL2 definition hasAbortedProcess: subProc2Id).
	self assert: (subProcCurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
	self assert: (subProcFinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
	self assert: (subProcCurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
	self assert: (subProcFinishedMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
	self assert: (subProcCurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
	self assert: (subProcFinishedMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.

	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenName[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenSurname[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'originCountry[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'gender[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenId[n]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'expirationDate[d]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.

	self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'checkApplicantRecord[s]' in: 'check-applicant-record') select: [:fieldValue | fieldValue processId = subProcId]) isEmpty.
	self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'offenseDate[d]' in: 'applicant-home-office-report') select: [:fieldValue | fieldValue processId = subProcId]) isEmpty.
	self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'offenseExpiration[d]' in: 'applicant-home-office-report') select: [:fieldValue | fieldValue processId = subProcId]) isEmpty.	

	self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'accountsDetails[s]' in: 'check-accounts') select: [:fieldValue | fieldValue processId = subProc2Id]) isEmpty.
	self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'debtsDetails[s]' in: 'check-debts') select: [:fieldValue | fieldValue processId = subProc2Id]) isEmpty.
	self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'assetValue[n]' in: 'financial-report') select: [:fieldValue | fieldValue processId = subProc2Id]) isEmpty.
	self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'assetType[s]' in: 'financial-report') select: [:fieldValue | fieldValue processId = subProc2Id]) isEmpty.! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 01/09/2018 15:13'!
testExecuteProcess_visaAborted_SubProc_L1_01
	| currentTask gateway subProcessL1 processId subProcId currentProcessMatrix finishedProcessMatrix subProcCurrentMatrix subProcFinishedMatrix |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.
	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').

	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.

	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.

	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 1).
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenName[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenSurname[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.	
	"Step 2 - Form [check-basic-data]"
	currentTask :=  procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.

	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data.

	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 2).
	self assert: ((procDefinition getCollectionForFieldsNamed: 'originCountry[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'gender[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	"Step 3 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'accept basic data').

	"Step 4 - Form [check-previous-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 2).

	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_check_previous_appliance.

	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 1).
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenId[n]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'expirationDate[d]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	"Sub Process Execution [home-office-check] starts here "
		subProcessL1 := procInstance subprocesses last.
		subProcId := subProcessL1 id.
		subProcCurrentMatrix := subProcessL1 getProcessMatrix.
		subProcFinishedMatrix := subProcessL1 getFinishedProcessMatrix.
 
		self assert: (procInstance includesSubProcess: subProcessL1).
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start visa check').

		"Step 1 [subproc] - Form [check-applicant-record]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'check-applicant-record').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.

		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_check_applicant_record: subProcessL1) on: subProcessL1.

		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 1).
		self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'checkApplicantRecord[s]' in: 'check-applicant-record') select: [:fieldValue | fieldValue processId = subProcId]) notEmpty.
		"here the process is cancelled"
		subProcessL1 abortProcess: nil.
		subProcessL1 currentState isConfirmed: true. 
		subProcessL1 confirmAbortion. "cancel all process tree -sub processes and the top process-"

		self assert: (subProcessL1 definition hasAbortedProcess: subProcId).
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
		self assert: (subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.

		self assert: (procDefinition hasAbortedProcess: processId).
		self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
		self assert: (finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
		self assert: (finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
		self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.

	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenName[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenSurname[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'originCountry[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'gender[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenId[n]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'expirationDate[d]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.

	self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'checkApplicantRecord[s]' in: 'check-applicant-record') select: [:fieldValue | fieldValue processId = subProcId]) isEmpty.! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 01/09/2018 15:18'!
testExecuteProcess_visaAborted_SubProc_L2_01
	| currentTask gateway subProcessL1 subProcessL2 processId currentProcessMatrix subProcId finishedProcessMatrix subProcCurrentMatrix subProcFinishedMatrix subProc2CurrentMatrix subProc2FinishedMatrix subProc2Id |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.
	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').

	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.

	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 1).
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenName[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenSurname[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	"Step 2 - Form [check-basic-data]"
	currentTask :=  procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.

	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data.

	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 2).
	self assert: ((procDefinition getCollectionForFieldsNamed: 'originCountry[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'gender[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	"Step 3 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'accept basic data').

	"Step 4 - Form [check-previous-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 2).

	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_check_previous_appliance.

	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 1).
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenId[n]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'expirationDate[d]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) notEmpty.
	"Sub Process Execution [home-office-check] starts here "
		subProcessL1 := procInstance subprocesses last.
		subProcId := subProcessL1 id.
		subProcCurrentMatrix := subProcessL1 getProcessMatrix.
		subProcFinishedMatrix := subProcessL1 getFinishedProcessMatrix.

		self assert: (procInstance includesSubProcess: subProcessL1).
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start visa check').

		"Step 1 [subproc] - Form [check-applicant-record]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'check-applicant-record').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_check_applicant_record: subProcessL1) on: subProcessL1.

		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 1).
		self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'checkApplicantRecord[s]' in: 'check-applicant-record') select: [:fieldValue | fieldValue processId = subProcId]) notEmpty.

		"Step 2 [subproc] - Form [applicant-home-office-report]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'applicant-home-office-report').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_applicant_home_office_report: subProcessL1) on: subProcessL1.

		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 2).
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
		self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'offenseDate[d]' in: 'applicant-home-office-report') select: [:fieldValue | fieldValue processId = subProcId]) notEmpty.
		self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'offenseExpiration[d]' in: 'applicant-home-office-report') select: [:fieldValue | fieldValue processId = subProcId]) notEmpty.

		"Sub Process Execution [check-financial-data]"
			subProcessL2 := subProcessL1 subprocesses last.
			subProc2Id := subProcessL2 id.
			subProc2CurrentMatrix := subProcessL2 getProcessMatrix.
			subProc2FinishedMatrix := subProcessL2 getFinishedProcessMatrix.
			self assert: (subProcessL1 includesSubProcess: subProcessL2).
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start financial check').

			"Step 1 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-accounts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_check_accounts: subProcessL2) on: subProcessL2.

			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).
			self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'accountsDetails[s]' in: 'check-accounts') select: [:fieldValue | fieldValue processId = subProc2Id]) notEmpty.

			"Step 2 [subproc] - Form [check-properties]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-properties').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew po' withForm: (self formInstance_check_properties: subProcessL2) on: subProcessL2.

			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).
			self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'propertiesDetails[s]' in: 'check-properties') select: [:fieldValue | fieldValue processId = subProc2Id]) notEmpty.

			"Step 3 [subproc] - Form [check-debts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-debts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew do' withForm: (self formInstance_check_debts: subProcessL2).

			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).
			self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'debtsDetails[s]' in: 'check-debts') select: [:fieldValue | fieldValue processId = subProc2Id]) notEmpty.

			"Step 4 [subproc] - Form [financial-report]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'financial-report').

			"here the process is cancelled"
			subProcessL1 abortProcess: nil.
			subProcessL1 currentState isConfirmed: true. 
			subProcessL1 confirmAbortion. "cancel all process tree -sub processes and the top process-"

			self assert: (subProcessL2 definition hasAbortedProcess: subProc2Id).
			self assert: (subProcCurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
			self assert: (subProcFinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
			self assert: (subProcCurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
			self assert: (subProcFinishedMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
			self assert: (subProcCurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
			self assert: (subProcFinishedMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProcId}) isEmpty.


			self assert: (subProcessL1 definition hasAbortedProcess: subProcId).
			self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.
			self assert: (subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.

			self assert: (procDefinition hasAbortedProcess: processId).
			self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
			self assert: (finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
			self assert: (finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
			self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.

	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenName[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenSurname[s]' in: 'citizen-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'originCountry[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'gender[s]' in: 'check-basic-data') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'citizenId[n]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.
	self assert: ((procDefinition getCollectionForFieldsNamed: 'expirationDate[d]' in: 'check-previous-appliance') select: [:fieldValue | fieldValue processId = processId]) isEmpty.

	self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'checkApplicantRecord[s]' in: 'check-applicant-record') select: [:fieldValue | fieldValue processId = subProcId]) isEmpty.
	self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'offenseDate[d]' in: 'applicant-home-office-report') select: [:fieldValue | fieldValue processId = subProcId]) isEmpty.
	self assert: ((subProcessL1 definition getCollectionForFieldsNamed: 'offenseExpiration[d]' in: 'applicant-home-office-report') select: [:fieldValue | fieldValue processId = subProcId]) isEmpty.	

	self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'accountsDetails[s]' in: 'check-accounts') select: [:fieldValue | fieldValue processId = subProc2Id]) isEmpty.
	self assert: ((subProcessL2 definition getCollectionForFieldsNamed: 'debtsDetails[s]' in: 'check-debts') select: [:fieldValue | fieldValue processId = subProc2Id]) isEmpty.! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 01/30/2018 13:50'!
testExecuteProcess_visaAccepted
	| currentTask gateway endArtifact subProcessL1 subProcessL2 processId currentProcessMatrix finishedProcessMatrix subProcId subProcCurrentMatrix subProcFinishedMatrix subProc2CurrentMatrix subProc2FinishedMatrix subProc2Id |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.

	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 1).

	"Step 2 - Form [check-basic-data]"
	currentTask :=  procInstance currentActivities last.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 2).

	"Step 3 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'accept basic data').

	"Step 4 - Form [check-previous-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_check_previous_appliance.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 1).

	"Sub Process Execution [home-office-check] starts here "
		subProcessL1 := procInstance subprocesses last.
		subProcId := subProcessL1 id.
		subProcCurrentMatrix := subProcessL1 getProcessMatrix.
		subProcFinishedMatrix := subProcessL1 getFinishedProcessMatrix.

		self assert: (procInstance includesSubProcess: subProcessL1).
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start visa check').

		"Step 1 [subproc] - Form [check-applicant-record]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'check-applicant-record').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_check_applicant_record: subProcessL1) on: subProcessL1.
		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 1).


		"Step 2 [subproc] - Form [applicant-home-office-report]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'applicant-home-office-report').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_applicant_home_office_report: subProcessL1) on: subProcessL1.
		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 2).
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.

		"Sub Process Execution [check-financial-data]"
			subProcessL2 := subProcessL1 subprocesses last.
			subProc2Id := subProcessL2 id.
			subProc2CurrentMatrix := subProcessL2 getProcessMatrix.
			subProc2FinishedMatrix := subProcessL2 getFinishedProcessMatrix.
			self assert: (subProcessL1 includesSubProcess: subProcessL2).
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start financial check').

			"Step 1 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-accounts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_check_accounts: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 2 [subproc] - Form [check-properties]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-properties').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew po' withForm: (self formInstance_check_properties: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 3 [subproc] - Form [check-debts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-debts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew do' withForm: (self formInstance_check_debts: subProcessL2).
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 4 [subproc] - Form [financial-report]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'financial-report').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_financial_report: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 2).
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.

			"Sub Process [check-financial-data] ends and gives control to previous process"
		"Sub Process [check-applicant-record] ends and gives control to main process"

	"Top Process [visa-appliance] resume execution "

	"Step 5 - Form [analyze-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'analyze-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_analyze_appliance.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 2).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.

	"Step 6 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'granted').

	"Step 7 - Form [emit-visa]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'emit-visa').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_emit_visa.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 3).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.

	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'visa apply end') and: [endArtifact isEndEvent]).! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 02/01/2018 09:54'!
testExecuteProcess_visaAccepted_02

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').

	self startFinishAndTestProcess: procInstance.! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 02/01/2018 09:56'!
testExecuteProcess_visaAccepted_03
	| currentTask currentProcessMatrix finishedProcessMatrix processId |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.

	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 1).

	self resumeFromTask2AndTestProcess: procInstance.! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 01/19/2018 13:16'!
testExecuteProcess_visaAcceptedPaused01
	| currentTask gateway endArtifact subProcessL1 subProcessL2 processId currentProcessMatrix finishedProcessMatrix subProcId subProcCurrentMatrix subProcFinishedMatrix subProc2CurrentMatrix subProc2FinishedMatrix subProc2Id |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	processId := procInstance id.
	currentProcessMatrix := procInstance getProcessMatrix.
	finishedProcessMatrix := procInstance getFinishedProcessMatrix.

	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 1).

	currentTask :=  procInstance currentActivities last.

	"TEST Paused Process"
	procInstance pauseProcess: nil. "the process is Paused"

	[self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data] on: ProcessNotRunningException do: [:ex | self assert: true].

	procInstance resumeProcess: nil. 

	"Step 2 - Form [check-basic-data]"
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa officer' satisfying: {:assign | assign.processId = processId}) size = 2).

	"Step 3 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'accept basic data').

	currentTask := procInstance currentActivities last.
	"TEST Paused Process"
	procInstance pauseProcess: nil. "the process is Paused"

	[self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_check_previous_appliance] on: ProcessNotRunningException do: [:ex | self assert: true].

	self assert: procInstance isPaused.
	procInstance resumeProcess: nil. 
	self assert: procInstance isRunning.

	"Step 4 - Form [check-previous-appliance]"
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_check_previous_appliance.
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 1).

	"Sub Process Execution [home-office-check] starts here "
		subProcessL1 := procInstance subprocesses last.
		subProcId := subProcessL1 id.
		subProcCurrentMatrix := subProcessL1 getProcessMatrix.
		subProcFinishedMatrix := subProcessL1 getFinishedProcessMatrix.

		self assert: (procInstance includesSubProcess: subProcessL1).
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start visa check').

		currentTask := subProcessL1 currentActivities last.
		"TEST Paused Process"
		subProcessL1 pauseProcess: nil. "the process is Paused"

		[self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_check_applicant_record: subProcessL1) on: subProcessL1] on: ProcessNotRunningException do: [:ex | self assert: true].
		self assert: procInstance isRunning. 

		self assert: subProcessL1 isPaused.
		subProcessL1 resumeProcess: nil. 
		self assert: subProcessL1 isRunning.

		"Step 1 [subproc] - Form [check-applicant-record]"
		self assert: (currentTask getDefinitionName = 'check-applicant-record').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_check_applicant_record: subProcessL1) on: subProcessL1.
		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 1).


		"Step 2 [subproc] - Form [applicant-home-office-report]"
		currentTask := subProcessL1 currentActivities last.
		self assert: (currentTask getDefinitionName = 'applicant-home-office-report').
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) notEmpty.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_applicant_home_office_report: subProcessL1) on: subProcessL1.
		self assert: ((subProcFinishedMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) size = 2).
		self assert: (subProcCurrentMatrix getAvailableTasksFor: 'visa checker' satisfying: {:assign | assign.processId = subProcId}) isEmpty.

		"Sub Process Execution [check-financial-data]"
			subProcessL2 := subProcessL1 subprocesses last.
			subProc2Id := subProcessL2 id.
			subProc2CurrentMatrix := subProcessL2 getProcessMatrix.
			subProc2FinishedMatrix := subProcessL2 getFinishedProcessMatrix.
			self assert: (subProcessL1 includesSubProcess: subProcessL2).
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start financial check').

			currentTask := subProcessL2 currentActivities last.

			"TEST Paused Process"
			subProcessL2 pauseProcess: nil. "the process is Paused"

			[self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_check_accounts: subProcessL2) on: subProcessL2] on: ProcessNotRunningException do: [:ex | self assert: true].

			self assert: procInstance isRunning. 
			self assert: subProcessL1 isRunning.
			self assert: subProcessL2 isPaused.
			subProcessL2 resumeProcess: nil. 
			self assert: subProcessL2 isRunning.

			"Step 1 [subproc] - Form [check-accounts]"
			self assert: (currentTask getDefinitionName = 'check-accounts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_check_accounts: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 2 [subproc] - Form [check-properties]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-properties').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew po' withForm: (self formInstance_check_properties: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 3 [subproc] - Form [check-debts]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'check-debts').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew do' withForm: (self formInstance_check_debts: subProcessL2).
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 1).

			"Step 4 [subproc] - Form [financial-report]"
			currentTask := subProcessL2 currentActivities last.
			self assert: (currentTask getDefinitionName = 'financial-report').
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) notEmpty.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_financial_report: subProcessL2) on: subProcessL2.
			self assert: ((subProc2FinishedMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) size = 2).
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'finance officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'debts officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.
			self assert: (subProc2CurrentMatrix getAvailableTasksFor: 'properties officer' satisfying: {:assign | assign.processId = subProc2Id}) isEmpty.

			"Sub Process [check-financial-data] ends and gives control to previous process"
		"Sub Process [check-applicant-record] ends and gives control to main process"

	"Top Process [visa-appliance] resume execution "

	"Step 5 - Form [analyze-appliance]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'analyze-appliance').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_analyze_appliance.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 2).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.

	"Step 6 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'granted').

	"Step 7 - Form [emit-visa]"
	currentTask := procInstance currentActivities last.
	self assert: (currentTask getDefinitionName = 'emit-visa').
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) notEmpty.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_emit_visa.
	self assert: ((finishedProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) size = 3).
	self assert: (currentProcessMatrix getAvailableTasksFor: 'visa manager' satisfying: {:assign | assign.processId = processId}) isEmpty.

	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'visa apply end') and: [endArtifact isEndEvent]).! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'brunobb 01/05/2018 13:11'!
testExecuteProcess_visaAnalizeAndRejected
	| currentTask gateway endArtifact subProcessL1 subProcessL2 |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	"Step 2 - Form [check-basic-data]"
	currentTask :=  procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	"Step 3 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'accept basic data').
	"Step 4 - Form [check-previous-appliance]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_check_previous_appliance.
	self assert: (currentTask getDefinitionName = 'check-previous-appliance').
	"Sub Process Execution [home-office-check] starts here "
		subProcessL1 := procInstance subprocesses last.
		self assert: (procInstance includesSubProcess: subProcessL1).
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start visa check').
		"Step 1 [subproc] - Form [check-applicant-record]"
		currentTask := subProcessL1 currentActivities last.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_check_applicant_record: subProcessL1) on: subProcessL1.
		self assert: (currentTask getDefinitionName = 'check-applicant-record').
		"Step 2 [subproc] - Form [applicant-home-office-report]"
		currentTask := subProcessL1 currentActivities last.
		self processTask: currentTask withUserNamed: 'andrew vc' withForm: (self formInstance_applicant_home_office_report: subProcessL1) on: subProcessL1.
		self assert: (currentTask getDefinitionName = 'applicant-home-office-report').
		"Sub Process Execution [check-financial-data]"
			subProcessL2 := subProcessL1 subprocesses last.
			self assert: (subProcessL1 includesSubProcess: subProcessL2).
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start financial check').
			"Step 1 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_check_accounts: subProcessL2) on: subProcessL2.
			self assert: (currentTask getDefinitionName = 'check-accounts').
			"Step 2 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self processTask: currentTask withUserNamed: 'andrew po' withForm: (self formInstance_check_properties: subProcessL2) on: subProcessL2.
			self assert: (currentTask getDefinitionName = 'check-properties').
			"Step 3 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self processTask: currentTask withUserNamed: 'andrew do' withForm: (self formInstance_check_debts: subProcessL2).
			self assert: (currentTask getDefinitionName = 'check-debts').
			"Step 3 [subproc] - Form [check-accounts]"
			currentTask := subProcessL2 currentActivities last.
			self processTask: currentTask withUserNamed: 'andrew fo' withForm: (self formInstance_financial_report: subProcessL2) on: subProcessL2.
			self assert: (currentTask getDefinitionName = 'financial-report').
			"Sub Process [check-financial-data] ends and gives control to previous process"
		"Sub Process [check-applicant-record] ends and gives control to main process"
	"Top Process [visa-appliance] resume execution "
	"Step 5 - Form [analyze-appliance]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'andrew vm' withForm: self formInstance_analyze_appliance_2.
	self assert: (currentTask getDefinitionName = 'analyze-appliance').
	"Step 6 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'granted').
	"Step 7 - Visa has been rejected"
	self assert: (procInstance currentActivities isEmpty).

	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'visa apply end') and: [endArtifact isEndEvent]).! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/23/2016 16:03'!
testExecuteProcess_visaRejected
	| currentTask gateway endArtifact |

	procInstance := procDefinition createAndStartProcessInstance: (users at: 'andrew vo').

	self assert: (procInstance startEvent getDefinitionName = 'visa apply start').
	"Step 1 - Form [citizen-appliance]"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_citizen_appliance.
	self assert: (currentTask getDefinitionName = 'citizen-appliance').
	"Step 2 - Form [check-basic-data]"
	currentTask :=  procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'andrew vo' withForm: self formInstance_check_basic_data_2.
	self assert: (currentTask getDefinitionName = 'check-basic-data').
	"Step 3 - Gateway Evaluation"
	gateway := procInstance executedGateways asOrderedCollection last.
	self assert: (gateway getDefinitionName = 'accept basic data').
	"Step 4 - Visa has been rejected"
	self assert: (procInstance currentActivities isEmpty).
	endArtifact := procInstance endEvents asOrderedCollection last.
	self assert: ((endArtifact getDefinitionName = 'visa apply end') and: [endArtifact isEndEvent]).! !

!VisaApplianceProcessExecutionTest methodsFor: 'test' stamp: 'BrunoBB 04/19/2016 16:13'!
testFieldsInGatewayConditions

	self assert: (procDefinition hasGatewayConditionIncludingFieldNamed: 'checkResult').

	self assert: (procDefinition hasGatewayConditionIncludingFieldNamed: 'applianceResult').

	self deny: (procDefinition hasGatewayConditionIncludingFieldNamed: 'name').

	self deny: (procDefinition hasGatewayConditionIncludingFieldNamed: 'surname').! !
